import( stdio clock )



( *** textmodus *** )
const bw40 0 ;
const co40 1 ;
const bw80 2 ;
const co80 3 ;
const mono 7 ;
const font8x8 256 ;
const c40 co40 ;
const c80 co80 ;

( *** Farben *** )
const black 0 ;
const blue 1 ;
const green 2 ;
const cyan 3 ;
const red 4 ;
const magenta 5 ;
const brown 6 ;
const lightgray 7 ;
const darkgray 8 ;
const lightblue 9 ;
const lightgreen 10 ;
const lightcyan 11 ;
const lightred 12 ;
const lightmagenta 13 ;
const yellow 14 ;
const white 15 ;
const blink 128 ;

OBJECT Crt 
  var checkbreak byte ;  ( boolean )
  var checkeof byte ;    ( boolean )
  var directvideo byte ; ( boolean )
  var checksnow byte ;   ( boolean )
  var lastmode word ; 
  var textattr byte ;
  var windmin word ;
  var windmax word ;
  var temp word ;
  
  proc init 
    $0000 @self_windmin b>m 
    24 , 79 combine 
    @self_windmax a>m
    $07 @self_textattr b>m
  ;
  
  
  proc clreol 
    c-xy? 1- b- bpush 8 shl bpop or d.cx a>m
    @self_textattr m>a 8 shl d.bx a>m
    @self_windmax m>bl d.dx bl>m
    $10 , $0600 intr
  ;
  
  proc clrscr 
    @self_textattr m>a 8 shl d.bx a>m
    @self_windmin m>a d.cx a>m
    @self_windmax m>a d.dx a>m
    $10 , $0600 intr
    @self_windmin m>a d.dx a>m
    0 d.bx b>m
    $10 , $0200 intr
  ;
  
  proc delay
    @self_temp b>m
    0timer 
    begin
      systime csec> bpush apush csec m>ba csec>
      dpop epop d/neg d/+ 
      @self_temp m>b .<.
    while
      systime csec> bpush apush csec m>ba csec>
      dpop epop d/neg d/+ 
    repeat
  ;
  
  proc delline
    0 d.bx b>m $10 , $0300 intr
    d.dx m>b d.cx b>m @self_windmin m>b d.cx bl>m
    @self_windmax m>b d.dx b>m
    d.dx m>a 8 shl a>b bpush
    d.cx m>a 8 shl bpop .=. if
      $10 , $0600 intr
    else
      $10 , $0601 intr
    endif
  ;
  
  proc gotoxy
    1- apush b>a 1- a>b apop
    combine d.dx a>m
    @self_windmin m>al d.dx m>bl + apush
    @self_windmin m>a 8 shr apush d.dx m>a 8 shr bpop + bpop 
    combine d.dx a>m
    @self_windmax m>bl d.dx m>al .>. if exit endif
    @self_windmax m>a 8 shr apush 
    d.dx m>a 8 shr bpop .>. if exit endif 
    d.dx m>al apush d.dx m>a 8 shr bpop xab combine d.dx a>m
    0 d.bx b>m
    $10 , $0200 intr
  ;
  
  proc highvideo
    @self_textattr m>a $08 or @self_textattr a>m
  ;
  
  proc lowvideo
    @self_textattr m>a $F7 and @self_textattr a>m
  ;
  
  proc normvideo
    @self_textattr $07 b>m
  ;
  
  proc insline
    0 d.bx b>m $10 , $0300 intr
    d.dx m>b d.cx b>m @self_windmin m>b d.cx bl>m
    @self_windmax m>b d.dx b>m
    d.dx m>a 8 shl a>b bpush
    d.cx m>a 8 shl bpop .=. if
      $10 , $0700 intr
    else
      $10 , $0701 intr
    endif
  ;
  
  proc nosound
    [ $E4 $61 ]  ( *** in al,[61] *** )
    [ $24 $FC ]  ( *** and al,fc  *** )
    [ $E6 $61 ]  ( *** out al,[61] ** )
  ;
  
  proc sound
    [ $B8 $DD $34 ]
    [ $BA $12 $00 ]
    [ $3B $D3 ]
    [ $73 $1A ]
    [ $F7 $F3 ]
    [ $8B $D8 ]
    [ $E4 $61 ]
    [ $A8 $03 ]
    [ $75 $08 ]
    [ $0C $03 ]
    [ $E6 $61 ]
    [ $B0 $B6 $E6 $43 $8A $C3 $E6 $42 $8A $C7 $E6 $42 ]
  ;
  
  proc textbackground
    b>a $07 and 4 shl apush
    @self_textattr m>a $8f and 
    bpop or @self_textattr al>m
  ;
  
  proc textcolor
    b>a
    [ $A8 $F0 ]
    [ $74 $04 ]
    [ $24 $0F ]
    [ $0C $80 ]
    apush 
    @self_textattr m>al $70 and 
    bpop or @self_textattr al>m
  ;
  
  proc textmode
  ;
  
  proc wherex
    d.bx 0 b>m 
    $10 , $0300 intr
    , 0
    d.dx m>al 
    0 @self_windmin m>bl -
    1+
  ;
  
  proc wherey
    d.bx 0 b>m
    $10 , $0300 intr
    0 , 0
    d.dx m>a 8 shr apush
    @self_windmin m>a 8 shr a>b apop -
    1+
  ;
  
  function window [ var y2 byte ;
  		    var x2 byte ;
  		    var y1 byte ;
  		    var x1 byte ; ]
   begin  		  
     0 , 0
     x1 local>al x2 local>bl .>. if exit endif
     y1 local>al y2 local>bl .>. if exit endif
     x1 local>al 1- apush @self_windmin m>a 8 shr a>b apop .<. if exit endif
     y1 local>al 1- @self_windmin m>bl .<. if exit endif
     x2 local>al 1- apush @self_windmax m>a 8 shr a>b apop .>. if exit endif
     y2 local>al 1- @self_windmax m>bl .>. if exit endif
     x1 local>al 1- 8 shl y1 local>al @self_windmin a>m
     x2 local>al 1- 8 shl y2 local>al @self_windmax a>m
     0 d.bx b>m
     $10 , $0200 intr
  ;
;


: main init
  crt_init
  blue crt_textbackground
  red crt_textcolor
  clrscr
  " HALLO" strprint cr
  wait
  clrscr
;    