import( KERN NUM )

( *********************** )
( ***** MEMORY.FTH: ***** )
( *********************** )


( ** NAXOS V2.11 Heap Manager ** )

var HeapBase  fptr ;   ( Heap Start SEG:OFS )
var HeapPtr   fptr ;   ( 1st Free location on Heap Seg:ofs )
var HeapEndptr fptr ;  ( End of heap seg:ofs )
var HeapBeg   double ; ( Heap Start 32Bit linear Address )
var HeapAct   double ; ( 1st Free loc. 32Bit lin. Addr. )
var HeapSize  double ; ( Heap size in Bytes 32 Bit ) 
var HeapEnd   double ; ( End of heap lin Addr. 32Bit )
	
( ***** elementare Pointer-Funktionen ***** )

           : ^norm 
( **  normalize pointer  ** )
( ************************* )
( arg: SI = pointer_adr     )
( out: -                    )
( chg: -                    )
( ************************* )
  [ $8B $14 ]       ( mov  dx,[si]   )
  [ $81 $24 *$000F ] ( and  [si],15   )
  [ $D1 $EA ]       ( shr  dx,1      )
  [ $D1 $EA ]       ( shr  dx,1      )
  [ $D1 $EA ]       ( shr  dx,1      )
  [ $D1 $EA ]       ( shr  dx,1      )
  [ $01 $54 2 ]     ( add  [si+2],dx )
;

   : ptr2lin
( ** seg:ofs pointer to linear 32Bit address ** )
( ****************************** )
( arg: SI = pointer_adr          )
(      DI = lin_ptr_adr	         )
( out: BX:AX lin_ptr     	 )   
( ****************************** )
  dpush
  m>ba
  apush
  b>a
  16 *
  ba>ed
  apop
  0
  d/+
  adrpop
  ba>m
;

   : lin2ptr
( * linear 32Bit address to seg:ofs pointer ** )
( ****************************** )
( arg: SI = lin_ptr_adr          )
(      DI = pointer_adr	         )
( out: ES:DI pointer     	 )   
( chg: ax bx es 		 )
( ****************************** )
  dpush
  m>ba $000F and apush
  m>ba d/2 d/2 d/2 d/2
  a>e dpop 
  adrpop ed>m
;      


         : ^move 
(  move i bytes via pointer )
(  regions must not overlap )
( ************************* )
( arg: SI = src_ptr_adr     )
(      DI = dest_ptr_adr    )
(      AX = Bytes to move i )
( out: -                    )
( chg: AX,ES,DI,SI          )
( ************************* )
  [ $91 ]     ( xchg ax,cx  )
  [ $8C $DA ] ( mov  dx,ds  )
  [ $C4 $3D ] ( les di,[di] ) ( Ziel nach es:di )
  [ $C5 $34 ] ( lds si,[si] ) ( Quelle nach ds:si )
  [ $D1 $E9 ] ( shr cx,1    )
  IF
  [ $41 ]     ( inc cx      )
  [ $A4 ]     ( movsb       )
  ENDIF
  [ $F3 $A5 ] ( rep movsw   ) ( move words )
  [ $8E $DA ] ( mov ds,dx   )
  [ $89 $C1 ] ( mov cx,ax   )
;


: ^cfill 
(  pointerset i bytes to c  )
( ************************* )
( arg: SI = ptr_adr         )
(      BX = char c          )
(      AX = Bytes to fill i )
( out: -                    )
( chg: ES,DI                )
( ************************* )
[ $89 $C2 ]  ( mov  dx,ax   )
[ $89 $D8 ]  ( mov  ax,bx   )
[ $87 $CA ]  ( xchg cx,dx   ) 
[ $C4 $3D ]  ( les  di,[si] ) ( Ziel nach es:di )
[ $F3 $AA ]  ( rep  stosb   ) ( ... und fllen )
[ $89 $D1 ]  ( mov  cx,dx   )
;

          : ^fill 
(  pointerset i words to n  )
( ************************* )
( arg: SI = ptr_adr         )
(      BX = value n         )
(      AX = words to fill i )
( out: -                    )
( chg: ES,DI                )
( ************************* )
[ $89 $C2 ]  ( mov  dx,ax   )
[ $89 $D8 ]  ( mov  ax,bx   )
[ $87 $CA ]  ( xchg cx,dx   ) 
[ $C4 $3F ]  ( les  di,[bx] ) ( Ziel nach es:di )
[ $F3 $AB ]  ( rep  stosw   ) ( ... und fllen )
[ $89 $D1 ]  ( mov  cx,dx   )
;


: ^n+ 
 ( -:n => ?:? )
       ( ptr => ptr )
( ** n zu Zeiger addieren ** )
( ************************* )
( arg: SI = ptr_adr         )
(      BX = value n         )
( out: -                    )
( chg: ES,DI                )
( ************************* )
  ^norm mem+n ^norm  ( Offset addieren und Zeiger normalisieren )
;


         : ^.nil=. 
( ** Pointer gleich Nil ? ** )
( ************************** )
( arg: SI = ptr_adr          )
( out: CF:=1 if seg=ofs=0    )
( chg: CF                    )
( ************************** )
[ $8B $14 ]    ( mov dx,[si]   )
[ $0B $54 $02 ] ( or  dx,[si+2] )
[ $F8 ]      ( clc           )
[ $75 $01 ]  ( jnz +1        )
[ $F9 ]      ( stc           )
;




( ***** Speicherverwaltung ***** )


: init overload
  initnonpu
  HeapSeg m>a HeapBase adr2+ a>m
  HEAPPARA CS: m>a 16 u*
  HeapSize ba>m
  HeapBase m>ba HeapPtr ba>m 
  heapbase to heapbeg ptr2lin
  heapptr to heapact ptr2lin
  Heapbeg m>ba Heapsize m>ed d/+ Heapend ba>m
  heapend to heapendptr lin2ptr
;  	  



: memalloc
( **  Allocate Heap ** )
( ** a first quite primitive approach ** )
( ** doesn't look for free mem adr adr<heapptr ** )
( ************************* )
( arg: SI = ptr_adr         )
(      BX:AX = Bytes req.   )
( out: -                    )
( chg: AX                   )
( ************************* )
  bapush
  adrpush       ( Pointer speichern )

  heapptr m>ed d>adr es: a>m adr2+ es: b>m  ( put Size in [ptr-6] )
  adr2+ apop apush es: a>m 		    ( put owner in [ptr-2] )
  heapact m>ed &6 d/+ bapush
  heapact to heapptr lin2ptr
  bapop heapact ba>m
  heapptr m>ba 2+ 2+ 2+ ba>m
  adrpop ba>m
  heapact m>ed bapop d/+ ba>m 
  heapact to heapptr lin2ptr
  heapend m>ba heapact m>ed d/- b>a $8000 and .0<>. IF
    " Heap overflow at " $. cs>a u.h ':' emit apop 4 - u.h cr
    halt
  ENDIF
;

var buf fptr ;
var buf1 double ;
: memdispose  
( ** Speicherblock freigeben ** )
( ** arg :  SI = pointer adr ** )
( ** out :  -		     ** )
( ** chg : ax bx es di	     ** )
( ***************************** )
   adrpush
   ^.nil=. IF
     " Illegal Pointer operation at " $. cs>a u.h ':' emit apop apop 4 - u.h cr
     halt
   ENDIF
   m>ed
   d>adr adr2- adr2- adr2-
   es: m>a adr2+ es: m>b adr2+ ( Size in BX:AX ) 
   epush dpush
   d/+ buf ba>m to buf1 ptr2lin
   heapact m>ed d/- .0=. IF dpop epop adrpop adrpush epush dpush
     ^norm m>ba heapptr ba>m to heapact ptr2lin  
     heapact m>ba d= &6 d/- ba>m to heapptr lin2ptr 
   ENDIF 
   dpop epop
   d= 0 es: d>m   ( Set MCB-Owner to NIL )
   adrpop d>m adr2+ d>m ( Set Ptr to NIL )
;


: MemAvail  
( ** Free Heap left **  )
( arg : -		)
( out : bx:ax bytes Heap )
  heapend m>ba 
  heapact m>ed d/-
;




memsizes( $FFFF $2000 )

var a fptr ;
var b fptr ;

: main init
  Memavail d. cr
  a &$0400 memalloc
  a m>ba apush b>a u.h ':' emit apop u.h cr
  Memavail d. cr 
  b &$0100 memalloc
  b m>ba apush b>a u.h ':' emit apop u.h cr
  Memavail d. cr 
  b MemDispose
  Memavail d. cr
  a MemDispose
  Memavail d. cr
  wait
;  