(
	************************************************************
	*         NAXOS Version 2.13  16-Bit Runtime library       *
	*                                                          *
	*         VGA VESA1.2 MODE GRAPHIC ROUTINES V1.02          *
	*                                                          *
	* (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
	*                                                          *
	*                      Rev. 13B 25.08.93                   *
	*                                                          *
	************************************************************
)



( Standard Modes available on all VGA )
(             ModeName     *$nnxx / nn=Devcaps# xx=Mode# )
	
	const 320x200x256  *$0213 ; ( 320x200 Pixel 256 color VGA/MCGA Mode )
	const 80x25x16     *$1703 ; ( VGA-16 color textmode )


( ---------------------------------------------------------------- )
(              Start of the card dependent patch Area              )
(		VESA 1.2 support				   )
( ---------------------------------------------------------------- )

( VESA modes )
(  		if mode >$7F then real mode = (mode and $7F)+$100 VESA )
(             ModeName     *$nnxx / nn=Devcaps# xx=Mode# )
	
	const 640x400x256  *$0A80 ;
	const 640x480x256  *$0B81 ;
	const 800x600x256  *$0D83 ;
	const 1024x768x256 *$0F85 ;

        const 320x200x32K  *$108D ;
	const 640x480x32K  *$1190 ;
	const 800x600x32K  *$1293 ;

        const 320x200x64K  *$138E ;
	const 640x480x64K  *$1491 ;
	const 800x600x64K  *$1594 ;

	const 640x480x16M  *$1692 ;

( VESA Bankswitch routines  )

	: wbanksel
	( arg : AX := PAGE to write into )
        [ $60 ]		( pusha )
	[ $89 $C2 ] 	( mov dx,ax )
	[ $BB *$0000 ] 	( mov bx,0000 )
	[ $B8 *$4F05 ]	( mov ax,4F05 )
	[ $CD $10 ]	( int 10 )
	[ $61 ]		( popa )
	;
	
	: rbanksel
	( arg : AX := PAGE to read from )	
        [ $60 ]		( pusha )
	[ $89 $C2 ] 	( mov dx,ax )
	[ $BB *$0001 ] 	( mov bx,0001 )
	[ $B8 *$4F05 ]	( mov ax,4F05 )
	[ $CD $10 ]	( int 10 )
	[ $61 ]		( popa )	
	;


(   devcaps  x-res y-res pages colors / all starting at zero )
(   colors in bytes 0=undef, 1=256, 2=32K, 3=64K, 4=16M )

var devcaps [ *319 *199 00 000  ( 000 )
	      *319 *199 07 000  ( 001 )
	      *319 *199 00 001  ( 002 )
 	      *639 *199 00 000  ( 003 )
	      *639 *199 03 000  ( 004 )
	      *639 *349 01 000  ( 005 )
	      *639 *349 01 000  ( 006 )
	      *639 *479 00 000  ( 007 )
	      *639 *479 00 000  ( 008 000-008 for compat. w/ VGAGRAF & BIOSGR)
	      *639 *350 00 001  ( 009 )
	      *639 *399 00 001  ( 00A )
	      *639 *479 00 001  ( 00B )      
	      *799 *599 00 000  ( 00C )
	      *799 *599 00 001  ( 00D )
	     *1023 *767 00 000  ( 00E )      
	     *1023 *767 00 001  ( 00F )
	      *319 *199 00 002  ( 010 )
	      *639 *479 00 002  ( 011 )
      	      *799 *599 00 002  ( 012 )
	      *319 *199 00 003  ( 013 )
	      *639 *479 00 003  ( 014 )
	      *799 *599 00 003  ( 015 )
	      *639 *479 00 004  ( 016 )
	       *79 *024 07 000 ] ; ( 017 )


var pix-x-max [ *79 ] ;
var pix-y-max [ *23 ] ;
var page-max  [ 8 ] ;
var color-max [ *15 ] ;

var page      [ 0 ] ;   
var pix-x     [ *0 ] ;
var pix-y     [ *0 ] ;

var color     [ $FF $FF ] ;
var colorh    [ $FF $00 ] ; ( byte in 256 col mode, word in HI, 3byte in 16M )

vector putpixel ;
vector getpixel ;

: setmode ( switch to graphics mode specified in bl -> mode constants )
    , $80 and .0=. IF
      d.bx b>m
    ELSE
      , $7F and $100 + d.bx a>m
    ENDIF
  , $4F02 $10 intr
;

: setmodenc ( as above with no clear screen )
    , $80 and .0=. IF
      d.bx , $8000 or a>m
    ELSE
      , $7F and $8100 + d.bx a>m
    ENDIF
  , $4F02 $10 intr
;




: entrymode ( restore initial videomode as on program entry )
  video-byte m>bl setmode
;

: setcolor ( set pixel color as in 256 palette mode )
  color bl>m 
;

var (calcr) word ;
var (calcg) word ;
var (calcb) word ;

: setrgb ( bl=red,al=green,di=blue)
 
  ( 16M colors 3 bytes/pixel )
  color d>m adr+ al>m adr+ bl>m   ( brg ET4000 mode )
 
  ( 64K colors 2 bytes/pixel )
  color-max m>a 3 .=. IF
    color       m>al u/2 u/2 u/2        (calcb) a>m	( red 5 Bit/pseudo 6 )
    color adr+  m>al u/2 u/2      5 shl (calcg) a>m 	( green 6 Bit )
    color adr2+ m>al u/2 u/2 u/2 11 shl (calcr) a>m	( blue 5 bit/pseudo 6 )
    (calcr) m>a (calcg) m>b or (calcb) m>b or color a>m
  ENDIF
 
  ( 32K colors 2 bytes/pixel )
  color-max m>a 2 .=. IF
    color       m>al u/2 u/2 u/2        (calcb)  a>m	( red 5 Bit )
    color adr+  m>al u/2 u/2 u/2  5 shl (calcg)  a>m 	( green 5 Bit )
    color adr2+ m>al u/2 u/2 u/2 10 shl (calcr)  a>m	( blue 5 bit )
    (calcr) m>a (calcg) m>b or (calcb) m>b or color a>m    
   ENDIF 
;


proc (putpixel-8) ( x-coord in bx; y-coord in ax; color is taken from pix-color )
  pusha
  e= $A000
  [ $89 $1E pix-x ]  ( mov pix-x,bx )
  [ $A3 pix-y ]      ( mov pix-y,ax )
  xab  a>d
  [ $A1 pix-x-max ] 1+ *
  [ $87 $DF ]        ( xchg BX,DI )
   + [ $83 $D7 $00 ] ( adc di,0 )
   a>adr
  d>a wbanksel
  [ $A0 color ]    ( mov al,color )
  es: al>m
  popa
;
  
proc (getpixel-8) ( x-coord in bx; y-coord in ax; color is returned in al )
  ipush
  e= $A000
  [ $89 $1E pix-x ]  ( mov pix-x,bx )
  [ $A3 pix-y ]      ( mov pix-y,ax )
  xab  a>d
  [ $A1 pix-x-max ] 1+ *
  [ $87 $DF ]        ( xchg BX,DI )
   + [ $83 $D7 $00 ] ( adc di,0 )
   a>adr
  d>a rbanksel
  es: m>al
  ipop
;

proc (putpixel-16) ( x-coord in bx; y-coord in ax; color is taken from pix-color )
  pusha
  e= $A000
  [ $89 $1E pix-x ]  ( mov pix-x,bx )
  [ $A3 pix-y ]      ( mov pix-y,ax )
  xab  a>d
  [ $A1 pix-x-max ] 1+ [ $D1 $E3 ] *
  [ $87 $DF ]        ( xchg BX,DI )
  [ $D1 $E3 ] 	     ( shl BX,1 )	
   + [ $83 $D7 $00 ] ( adc di,0 )
   a>adr
  d>a wbanksel
  [ $A1 color ]    ( mov ax,color )
  es: a>m
  popa
;
  
proc (getpixel-16) ( x-coord in bx; y-coord in ax; color is returned in al )
  ipush
  e= $A000
  [ $89 $1E pix-x ]  ( mov pix-x,bx )
  [ $A3 pix-y ]      ( mov pix-y,ax )
  xab  a>d
  [ $A1 pix-x-max ] 1+ [ $D1 $E3 ] *
  [ $87 $DF ]        ( xchg BX,DI )
  [ $D1 $E3 ]
   + [ $83 $D7 $00 ] ( adc di,0 )
   a>adr
  d>a rbanksel
  es: m>a
  ipop
;
proc (putpixel-24) ( x-coord in bx; y-coord in ax; color is taken from pix-color )
  pusha
  e= $A000
  [ $89 $1E pix-x ]  ( mov pix-x,bx )
  [ $A3 pix-y ]      ( mov pix-y,ax )
  xab  a>d
  [ $A1 pix-x-max ] 1+ [ $89 $DA $D1 $E3 $01 $D3 ] *
  [ $87 $DF ]        ( xchg BX,DI )
  [ $89 $DA ]	     ( mov dx,bx )
  [ $D1 $E3 ] 	     ( shl BX,1 )	
  [ $01 $D3 ] 	     ( add bx,dx )
   + [ $83 $D7 $00 ] ( adc di,0 )
   a>adr
  d>a wbanksel
  [ $A1 color ]    	( mov ax,color )
  [ $8A $1E colorh ] 	( mov bl,color+2 )
  es: a>m adr2+ es: bl>m
  popa
;
  
proc (getpixel-24) ( x-coord in bx; y-coord in ax; color is returned in al )
  ipush
  e= $A000
  [ $89 $1E pix-x ]  ( mov pix-x,bx )
  [ $A3 pix-y ]      ( mov pix-y,ax )
  xab  a>d
  [ $A1 pix-x-max ] 1+ [ $89 $DA $D1 $E3 $01 $D3 ] *
  [ $87 $DF ]        ( xchg BX,DI )
  [ $89 $DA ]	     ( mov dx,bx )
  [ $D1 $E3 ] 	     ( shl BX,1 )	
  [ $01 $D3 ] 	     ( add bx,dx ) 
   + [ $83 $D7 $00 ] ( adc di,0 )
   a>adr
  d>a rbanksel
  es: m>a adr2+ es: m>bl
  
  ipop
;


: hline ( x1-coord in bx;y coord in ax; x2-coord in di )
  dpush
  putpixel
  dpop
  d>a pix-x m>b - a>b FOR
    pix-x m>b b+ b>m pix-y m>a putpixel
  next
;


: vline ( x1-coord in bx;y coord in ax; y2-coord in di )
  putpixel
  d>a pix-y m>b - a>b FOR
    pix-x m>b pix-y m>a 1+ a>m putpixel
  next
;

var BG-x1 word ;
var BG-y1 word ;
var BG-xd word ;
var BG-yd word ;
var BG-xf word ;




: line  ( input: x1: BX, y1: AX, x2: ES, y2: DI )
	( output: - )
	( CX is modified ! )
	
[ $89 $DA ] d>b
[ $89 $1E BG-y1 $E8 $96 $00 $89 $0E BG-yd $E8 $AE ]
[ $00 $92 ]
e>b
[ $89 $1E BG-x1 $E8 $85 $00 $89 $0E BG-xd $E8 $9D ]
[ $00 $8B $D8 $3B $DA $7E $3C $8B $C2 $03 $C0 $2B $C3 $A3 BG-xf ]
[ $8B $CB $41 $E8 $75 $00 $A1 BG-xf $0B $C0 $7E $15 $03 $C2 $03 ]
[ $C2 $2B $C3 $2B $C3 $A3 BG-xf $A1 BG-yd $01 $06 BG-y1 $EB ]
[ $08 $90 $03 $C2 $03 $C2 $A3 BG-xf $A1 BG-xd $01 $06 BG-x1 ]
[ $E2 $D1 $C3 $8B $C3 $03 $C0 $2B $C2 $A3 BG-xf $8B $CA $41 $E8 ]
[ $39 $00 $A1 BG-xf $0B $C0 $7E $15 $03 $C3 $03 $C3 $2B $C2 $2B ]
[ $C2 $A3 BG-xf $A1 BG-xd $01 $06 BG-x1 $EB $08 $90 $03 $C3 ]
[ $03 $C3 $A3 BG-xf $A1 BG-yd $01 $06 BG-y1 $E2 $D1 $C3 $33 ]
[ $C9 $2B $C3 $74 $05 $78 $02 $41 $C3 $49 $C3 $52 $53 $50 $8B ]
[ $1E BG-x1 $A1 BG-y1 ]
 putpixel
[ $58 $5B $5A $C3 ]
[ $0B $C0 $79 $02 $F7 $D8 $C3 ]
;


: lineto ( x in BX , y in AX )
  [ $06 $51 ] ( push es , push cx )
  bpush apush
  a>d b>e
  pix-x m>b pix-y m>a
  line
  apop pix-y a>m apop pix-x a>m
  [ $59 $07 ] ( pop cx , pop es )
;


: graphmode ( switch to graphicsmode / input: mode.const in BX ) 
  bpush B>a split b>a 6 * devcaps adrn+ to pix-x-max , 6 i/copy
  apop split a>b setmode
  color-max m>a
  case
  2 OF make putpixel (putpixel-16) make getpixel (getpixel-16) ;;
  3 OF make putpixel (putpixel-16) make getpixel (getpixel-16) ;;
  4 OF make putpixel (putpixel-24) make getpixel (getpixel-24) ;;
  else make putpixel (putpixel-8)  make getpixel (getpixel-8)	  
  endcase
  pix-y-max ( this line was added to suit var-usage by optimizing V2.14 compiler )
;

: graphmodenc ( switch to graphicsmode / input: mode.const in BX ) 
  bpush B>a split b>a devcaps adrn+ to pix-x-max , 6 i/copy
  apop split a>b setmodenc 
  color-max m>a
  case
  2 OF make putpixel (putpixel-16) make getpixel (getpixel-16) ;;
  3 OF make putpixel (putpixel-16) make getpixel (getpixel-16) ;;
  4 OF make putpixel (putpixel-24) make getpixel (getpixel-24) ;;
  else make putpixel (putpixel-8)  make getpixel (getpixel-8)	  
  endcase  
  pix-y-max
;

: textmode ( switch to standard 80x25 Textmode )
  80x25x16 graphmode  
;

: textmodenc ( as above with no clear screen )
  80x25x16 graphmodenc  
;
