include stdio

( VIA VT82C480 Configuration register : port 22= index  )
(					port 23= data/w )
( index range C0..CF				     	)

var cmr byte 255 ;

: putchip ( BX=index out AL reg )
  [ $93		( xchg ax,bx  )
    $22E6	( out [22],al )
    $EBE7	( out [EB],ax )
    $93		( xchg ax,bx  )
    $23E6	( out [23],al )
  ]  
;

: getchip ( BX=index, AL=Value )
  [ $93		( xchg ax,bx  )
    $22E6	( out [22],al )
    $EBE7	( out [EB],ax )
    $23E4	( in  [23],al )
  ]  
;

: getcmos ( BX=index , out al=byte )
  [ $93		( xchg ax,bx  )
    $70E6	( out [70],al )
    $EBE7	( out [EB],ax )
    $71E4	( in  [71],al )
  ]  
;

: putcmos ( BX=index , AL = data )
  [ $93		( xchg ax,bx  )
    $70E6	( out [70],al )
    $EBE7	( out [EB],ax )
    $93		( xchg ax,bx  )
    $71E6	( out [71],al )
  ]  
;


: main init
  " VIA-Technology VT82C480 chip setup" $. cr
  " with Award(tm) BIOS" $. cr
  " (C) 1994 by A.Zissis" $. cr cr
  " Reading CMOS-Data .." $.
  $00 , $FF DO
    i>b getcmos a>b cmr i adrn+ bl>m 
    ( b>a u.d cr )
  LOOP
  '.' emit cr
  " Time : " $.
  cmr adr2+ adr2+  m>al byte.h ':' emit cmr adr2+ m>al byte.h 
  '/' emit cmr m>al byte.h 
  "    Date: " $.
  cmr , 7 adrn+ m>al byte.h '.' emit cmr , 8 adrn+ m>al byte.h " .19" $.
  cmr , 9 adrn+ m>al byte.h cr
  cr  
  " Status A : $" $. , $A cmr adrn+ m>al byte.h cr
  " Status B : $" $. , $b cmr adrn+ m>al byte.h cr
  " Status C : $" $. , $c cmr adrn+ m>al byte.h cr
  " Status D : $" $. , $d cmr adrn+ m>al byte.h cr      
  " Diagnose : $" $. , $e cmr adrn+ m>al byte.h cr        
  " Shutdown : $" $. , $f cmr adrn+ m>al byte.h cr      
  cr
  " Diskette A: = " $.
  cmr , $10 adrn+ m>al $F0 and u/2 u/2 u/2 u/2 byte.h cr
  " Diskette B: = " $.
  cmr , $10 adrn+ m>al $0F and byte.h cr
  cr
  " HD0 (C:) = " $.
  cmr , $12 adrn+ m>al $F0 and u/2 u/2 u/2 u/2 u.d 
  "   XHD0 = " $. cmr , $19 adrn+ m>al u.d cr
  " HD1 (D:) = " $.
  cmr , $12 adrn+ m>al $0F and u.d
  "   XHD1 = " $. cmr , $1A adrn+ m>al u.d cr
  
  " Plattenparameter USER-TYPE 48 " $. cr
  " Cylinders: " $. cmr , $1E adrn+ m>al adr+ m>ah u.d
  "   Heads: " $. cmr , $20 adrn+ m>al u.d
  "   Sectors: " $. cmr , $25 adrn+ m>al u.d
  "   Precomp: " $. cmr , $21 adrn+ m>al adr+ m>ah u.d  
  "   LZone: " $. cmr , $23 adrn+ m>al adr+ m>ah u.d
  cr
  " Plattenparameter USER-TYPE 49 " $. cr
  " Cylinders: " $. cmr , $26 adrn+ m>al adr+ m>ah u.d
  "   Heads: " $. cmr , $28 adrn+ m>al u.d
  "   Sectors: " $. cmr , $2D adrn+ m>al u.d
  "   Precomp: " $. cmr , $29 adrn+ m>al adr+ m>ah u.d  
  "   LZone: " $. cmr , $2B adrn+ m>al adr+ m>ah u.d
  cr
  cr
  $30 , $3F do
     i byte.h ':' emit cmr i adrn+ m>al byte.h "    " $.
     i 1+ byte.h ':' emit cmr i 1+ adrn+ m>al byte.h "    " $.
     i 2+ byte.h ':' emit cmr i 2+ adrn+ m>al byte.h "    " $.
     i 2+ 1+ byte.h ':' emit cmr i 2+ 1+ adrn+ m>al byte.h "    " $. 
     
     i 2+ 2+ byte.h ':' emit cmr i 2+ 2+ adrn+ m>al byte.h "    " $.
     i 2+ 2+ 1+ byte.h ':' emit cmr i 2+ 2+ 1+ adrn+ m>al byte.h "    " $.
     i 2+ 2+ 2+ byte.h ':' emit cmr i 2+ 2+ 2+ adrn+ m>al byte.h "    " $.
     i 2+ 2+ 2+ 1+ byte.h ':' emit cmr i 2+ 2+ 2+ 1+ adrn+ m>al byte.h "    " $. 
     cr
  , 8 +loop   
;