(
        ************************************************************
        *         NAXOS Version 2.14  16-Bit Runtime library       *
        *                                                          *
        *    OPERATING SYSTEM APPLICATION INTERFACE MS-DOS V1.1    *
        *                                                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 14A 27.11.95                   *
        *                                                          *
        ************************************************************
)



	( ***************************************** )
	( **    Interrupt Interface for DOS      ** )
	( ***************************************** )

	( ** interrupt routines for MS-DOS and intr ** )


		MACRO dos 
	( ** call interrupt# $21 ** )
	( arg: BL = function number )
	(      AL = subfunction#    )
	( out: AX:= function/subf   )
	(      BL:= $21             )
	( chg: AH,BL                )
	( ************************* )
	[ $88 $DC ]  ( mov ah,bl    )
	[ $B3 $21 ]  ( mov bl,#$21  )
	;


		  : ?doserr 
	( ** possible error after intr ** )
	( arg: CF =1:error =0: no error   )
	(      AH = functionnumber        )
	(      AL = subfunctionnumber     )
	( out: CF:= 0 if error            )
	( chg: ? if error                 )
	( ******************************* )
	IF                ( error ?       )
         [ $89 $E3 ]
         apush
         [ $36 $8B $07 ] a>d
         apop
	 [ $8b $1e D.AX ] ( mov bx,[d.ax] )
	 doserr .F.
	ELSE .T.
	ENDIF
	;

		  macro getint 
	( ** int_routine for INT# i ** )
	( **************************** )
	( arg: BX = interrupt_number i )
	( out: ES:DI:= adr of int_rout )
	( chg: ES,DI,AX                )
	( **************************** )
	[ $88 $D8 ]       ( mov al,bl  )
	[ $B4 $35 ]       ( mov ah,#35 )
	[ $CD $21 ]       ( int 21     )
	[ $89 $DF ]       ( mov di,bx  ) 
	;

	: setint 
	( ** Setze Interrupt Nummer i ** )
	( load int_routine for INT# i  )
	( **************************** )
	( arg: BX = interrupt_number i )
	(      ES:DI:= adr of int_rout )
	( out: -                       )
	( chg: AX                      )
	( **************************** )
	[ $1E ]           ( push ds    )
	[ $8C $C0 ]       ( mov ax,es  )
	[ $8E $D8 ]       ( mov ds,ax  )
	[ $89 $FA ]       ( mov dx,di  )
	[ $88 $D8 ]       ( mov al,bl  )
	[ $B4 $25 ]       ( mov ah,#25 )
	[ $CD $21 ]       ( int 21     )
	[ $1F ]           ( pop ds     )
	;

	proc (emit)  ( c,- )
		     ( - )
		     ( - ) 
	( ** Zeichen c auf Schirm ausgeben ** )
	 [ $50 ]     ( push ax    )
	 [ $88 $DA ] ( mov dl,bl  )
	 [ $B4 $02 ] ( mov ah,#02 )
	 [ $CD $21 ] ( int 21     )
	 [ $58 ]     ( pop ax     )
	;

	proc (pemit)  ( c,- )
		      ( - )
		      ( - ) 
	( ** Zeichen c auf PRN ausgeben ** )
	 [ $50 ]     ( push ax    )
	 [ $88 $DA ] ( mov dl,bl  )
	 [ $B4 $05 ] ( mov ah,#05 )
	 [ $CD $21 ] ( int 21     )
	 [ $58 ]     ( pop ax     )
	;


		proc (key) 
	( ** Taste  holen ** )
	( ************************ )
	( arg: -                   )
	( out: AL:= asci_val       )
	( chg: AX                  )
	( ************************ )             
	[ $B4 $01 ]   ( mov ah,#01 )
	[ $CD $21 ]   ( int 21     )
	[ $B4 $00 ]   ( mov ah,#00 )
	[ $C3 ]       ( ret        )
	;

		proc (key-noecho) 
	( ** Taste  holen ** )
	( ************************ )
	( arg: -                   )
	( out: AL:= asci_val       )
	( chg: AX                  )
	( ************************ )             
	[ $B4 $07 ]   ( mov ah,#07 )
	[ $CD $21 ]   ( int 21     )
	[ $B4 $00 ]   ( mov ah,#00 )
	[ $C3 ]       ( ret        )
	;

	proc .?key.  ( => -,? ) ( f )
		     ( - )
		     ( - )
	( ** f:=1 : Zeichen vorhanden ** )
	[ $B4 $0B ] ( mov ah,#$B )
	[ $CD $21 ] ( int 21h    )
	[ $D0 $D8 ] ( rcr al,1   ) 

	;

        proc (OS-TIME)
( **  get systemtime ** )
( ********************* )
( arg: -                )
( out: AH:= hour        )
(      AL:= minutes     )
(      BH:= seconds     )
(      BL:= centisecs   )
( chg: AX,BX            )
( ********************* )
[ $B4 $2C ] ( mov ah,2c )
[ $CD $21 ] ( int 21    )
[ $89 $C8 ] ( mov ax,cx )
[ $89 $D3 ] ( mov bx,dx )
;

       proc (OS-DATE)
( ***  get systemdate *** )
( *********************** )
( arg: -                  )
( out: BX:= year          )
(      AH:= month         )
(      AL:= day           )
(      DI-L:= day of week ) 
( chg: AX,BX,DI           )
( *********************** )
[ $B4 $2A ] ( mov ah,2A )
[ $CD $21 ] ( int 21    )
[ $89 $C7 ] ( mov di,ax )
[ $89 $CB ] ( mov ax,dx )
[ $89 $D0 ] ( mov bx,cx )
;

: (OS-CLS)
  ( Clear screen using BIOS )
	
	$0700 d.bx b>m 0 d.cx b>m 
	$1950 d.dx b>m
	A= $0600 $10 intr
	0 d.dx b>m d.bx b>m
	A= $0200 $10 intr
;
( -------------------------------- )

const R/O *$0010 ;
const W/O *$0011 ;
const R/W *$0012 ;

var recsize  [ *$0001 ] ; 
var filemode [ R/W ] ;
var fileattr [ *$0000 ] ;


        macro ($PTR) 
( * adjust DOS_stringpointer * )
( * string must terminate 0! * )
( **************************** )
( arg: SI = string_adr         )
( out: -                       )
( chg: -                       )
( **************************** )
[ $89 $36 d.dx ] ( mov d.dx,si )
[ $8C $1E d.ds ] ( mov d.ds,ds ) 
;

          : setdrive 
( **  change actual drive   ** )
( **************************** )
( arg: BX = drive A=1 B=2 ..   )
( out: -                       )
( chg: BX                      )
( **************************** )
[ $4B ]          ( dec BX      )
[ $89 $1E d.dx ] ( mov d.dx,bx )
$0E dos intr
;


         : getdrive 
( ****  get actual drive   *** )
( **************************** )
( arg: -                       )
( out: AX = drive 1=A 2=B ..   )
( chg: AX,BX                   )
( **************************** )
$19 dos intr
[ $A1 d.ax ]     ( mov ax,d.ax )
ah0 1+ 
;


          : mkdir 
( ****  make new directory *** )
( **************************** )
( arg: SI = dirname_adr        )
( out: CF:=0 if no error       )
( chg: AX,BX,CF                )
( **************************** )
($PTR) $39 dos intr ?doserr
;


          : rmdir 
( ****  delete directory  **** )
( **************************** )
( arg: SI = dirname_adr        )
( out: CF:=0 if no error       )
( chg: AX,BX,CF                )
( **************************** )
($PTR) $3A dos intr ?doserr
;


          : chdir 
( * change current directory * )
( **************************** )
( arg: SI = dirname_adr        )
( out: CF:=0 if no error       )
( chg: AX,BX,CF                )
( **************************** )
($PTR) $3B dos intr ?doserr
;
         : path? 
( copy pathname into buffer )
( ************************* )
( arg: BX = drive           )
(           0 = current     )
(           1 = A, 2 = B    )
(      SI    = buffer_adr   )
( out: doserr               )
( chg: ?                    )
( ************************* )
  adrpush
  d.dx bl>m
  ds>a
  d.ds a>m
  apop
  d.si a>m
  $47  dos intr ?doserr
;




         : exist? 
( ***  does file exist?  *** )
( ************************** )
( arg: SI = filename_adr     )
( out: CF:= 1 if file exists )
( chg: AX,BX                 )
( ************************** )
($PTR) , 0 
[ $A3 d.ax ]  ( mov d.ax,ax  )
$3D dos intr  ( try to open  )
IF   .F.      ( not existing )
ELSE          ( yes, close   )
 [ $A1 d.ax ] ( mov ax,d.ax  )
 [ $A3 d.bx ] ( mov d.bx,ax  )
 $3E dos intr .T.
ENDIF  
;


           : ferase 
( ***  erase existing file ** )
( ************************** )
( arg: SI = filename_adr     )
( out: CF:= 0 if no error    )
( chg: AX,BX,CF              )
( ************************** )
exist?
IF
  ($PTR) $41 dos intr ?doserr
ENDIF
;


           : frename 
( *** rename existing file *** )
( **************************** )
( arg: SI = filename_adr old   )
(      DI = filename_adr new   )
( out: CF:=0 if no error       )
( chg: SI,DI,AX,BX,CF          )
( **************************** )
[ $89 $36 d.dx ] ( mov d.dx,si )
[ $89 $3E d.di ] ( mov d.di,di )
[ $8C $1E d.ds ] ( mov d.ds,ds )
[ $8C $1E d.es ] ( mov d.es,ds )
$56 dos intr ?doserr
;

            : drivespace 
( get total/remaining drive capacity  )
( *********************************** )
( arg: BX: 0= current drive 1=A 2=B.. )
( out: BX:AX = Bytes free on Volume   )	
(      ES:DI = Bytes total on Volume  )
( chg: AX,BX,DI,ES,CF                 )
( *********************************** )

[ $89 $1E d.dx ]
$36 dos intr
d.ax 
( IF- OFF .T. )
  [ $A1 d.ax ]		( mov ax,d.ax  Sec/Cluster )
  [ $8B $1E d.cx ]	( mov bx,d.cx  Byte/Sec )
  u*			( Byte / Cluster )
  apush
  [ $8B $1E d.dx ]	( mov bx,d.dx Total cluster )  
  u*
  b>e a>d
  apop
  [ $8B $1E d.bx ]	( mov bx,d.bx Free Cluster )
  u*
( ELSE .F. )
( ENDIF )
;

          : getdta 
( get adr of disk-transfer-area )
( ***************************** )
( arg: -                        )
( out: ES:DI dta_adr            )
( chg: ES,DI                    )
( ***************************** )
$2F dos intr
[ $8E $06 d.es ]  ( mov es,d.es )
[ $8B $3E d.bx ]  ( mov di,d.bx )
;




          : get-file-atr
( *****  get file atribut ***** )
( ***************************** )
( arg: SI = filename_adr        )
( out: AX = atribut             )
(         = 0: unlimited access )
(         = 8: name of volume   )
(           else BIT:           )
(           0=1: read only      )
(           1=1: hidden file    )
(           2=1: system file    )
(           4=1: subdirectory   )
(           5=1: changed        )
(      CF:=0 if no error        )
( chg: AX,BX,CF                 )
( ***************************** )
($PTR) , 0 
[ $A3 d.ax ]      ( mov d.ax,ax )
$43 dos intr ?doserr
[ $A1 d.cx ]      ( mov ax,d.cx )
;


          : set-file-atr
( *****  set file atribut ***** )
( ***************************** )
( arg: SI = filename_adr        )
(      BX = atribut             )
(         = 0: unlimited access )
(         = 8: name of volume   )
(           else BIT:           )
(           0=1: read only      )
(           1=1: hidden file    )
(           2=1: system file    )
(           4=1: subdirectory   )
( out: CF:=0 if no error        )
( chg: AX,BX,CF                 )
( ***************************** )
($PTR) 
[ $89 $1E d.cx ]  ( mov d.cx,bx ) 
, 1 
[ $A3 d.ax ]      ( mov d.ax,ax ) 
$43 dos intr ?doserr
;


( ** directory-searchfunctios ** )
var dirbuf string 66 ; ( buffer for filenames )

            : dirfirst? 
( * find first file with atr n  )
( ***************************** )
( arg: SI = searchfilename_adr  )
(           * and ? are valid   )
(      BX = atribut n           )
(         = 0: unlimited access )
(         = 8: name of volume   )
(           else BIT:           )
(           0=1: read only      )
(           1=1: hidden file    )
(           2=1: system file    )
(           4=1: subdirectory   )
(           5=1: changed        )
( out: CF:= 1 if no error       )
(      ES:DI:= found_name_adr   )
( chg: AX,BX,ES,DI              )
( ***************************** )
($PTR)   d.cx b>m   $2F dos intr
[ $8E $06 d.es ]  ( mov es,d.es )
[ $8B $3E d.bx ]  ( mov di,d.bx )
[ $83 $C7 $1E ]   ( add di,1E   )
$4E dos intr .not.

;


           : dirnext? 
( *****  find next file   ***** )
( ***************************** )
( arg: ES:DI found_name_adr     )
( out: CF:= 0 if no error       )
( chg: AX,BX,ES,DI              )
( ***************************** )
$4F dos intr .not.
;

: dirattr 
( * attribute of found file )
( ************************* )
( arg: ES:DI found_name_adr )
( out: AL:= attribute       )
( chg: AX                   )
( ************************* )
ah0
[ $26 $8A $45 $F7 ] ( mov al,es:[di-9] )
;

        : dirtime 
( **  time of found file   ** )
( *************************** )
( arg: ES:DI found_name_adr   )
( out: AX:= hour 0-24         )
(      BX:= minutes 0-59      )
(      SI:= seconds 0-59      )
( chg: -                      )
( *************************** )
[ $26 $8B $45 $F8 ] ( mov ax,es:[di-8] )
a>b a>adr ipush
[ $B1 $0B ]      ( mov cl,11  )
[ $D3 $E8 ]      ( shr ax,cl  )
[ $25 *$1F ]     ( and ax,$1f )
[ $B1 $05 ]      ( mov cl,05  )
[ $D3 $EB ]      ( shr bx,cl  )
[ $81 $E3 *$3F ] ( and bx,$3f )
[ $D1 $E6 ]      ( shl si,1   )
[ $81 $E6 *$1F ] ( and si,$1f )
ipop
;

         : dirdate 
( **  date of found file   ** )
( *************************** )
( arg: ES:DI found_name_adr   )
( out: BX:= year              )
(      AH:= month 1 - 12      )
(      AL:= day   1 - 31      )
( chg: -                      )
( *************************** )
[ $26 $8B $45 $FA ] ( mov ax,es:[di-6] )
a>b ipush 
[ $89 $C2 ]	 ( mov dx,ax )
[ $B1 $09 ]      ( mov cl,09  )
[ $D3 $E8 ]      ( shr ax,cl  )
[ $25 *$7F ]     ( and ax,$7f )
[ $05 1980 ]     ( add ax,1980 )
[ $B1 $05 ]      ( mov cl,05  )
[ $D3 $EB ]      ( shr bx,cl  )
[ $88 $DF ]	 ( mov bh,bl )
[ $88 $D3 ]	 ( mov bl,dl )
[ $E381 $0F1F ]	 ( and bx,$0F1F )
xab
ipop
;

       : dirsize 
( ** length of found file ** )
( ************************** )
( arg: ES:DI found_name_adr  )
( out: BX:AX:= length        )
( chg: AX,BX                 )
( ************************** )
[ $26 $8B $45 $FC ] ( mov ax,es:[di-4] )
[ $26 $8B $5D $FE ] ( mov al,es:[di-9] )
;

: (fopen)
( arg: addr of file-var in SI )

  adrpush adr2+ m>a d.ax a>m
  apop apush $0A + a>adr m>ba d.dx a>m d.ds b>m
  d.ax m>a $3D dos intr ?doserr
  d.ax m>a adrpop a>m
  , $E adrn+ false bl>m
;

: (fcreate)
( in: addr of file-var in SI )

  adrpush adr2+ m>a d.ax a>m
  fileattr m>a d.cx a>m
  apop apush $0A + a>adr m>ba d.dx a>m d.ds b>m
  d.ax m>a $3C dos intr ?doserr
  d.ax m>a adrpop a>m
  , $E adrn+ false bl>m

;

: (fclose)
( in: addr of file-var in SI )
 m>a d.bx a>m
 $3E dos intr ?doserr 
;

: (fseek)
( in : addr of file-var in si )
(      pos in bx,ax  	      )
( out: pos in bx,ax  	      )

 m>d d.bx d>m
 d.dx a>m d.cx b>m
 $42 , 0 dos intr ?doserr
 d.dx m>b d.ax m>a 
;

: (filepos)
( in : addr of file-var in si )
( out: pos in bx,ax  	      )

 m>d d.bx d>m
 d.dx 0 b>m d.cx 0 b>m
 $42 , 1 dos intr ?doserr
 d.dx m>b d.ax m>a 
;

var (fsize) double ;
: filesize
( in : addr of file-var in si )
( out: filesize in bx,ax      )
 adrpush
 (filepos) (fsize) ba>m 
 adrpop adrpush
 m>d d.bx d>m
 d.dx 0 b>m d.cx 0 b>m
 $42 , 2 dos intr ?doserr
 d.dx m>b d.ax m>a adrpop bapush adrpush
 (fsize) m>ba adrpop (fseek)
 bapop
;

: fget
( arg:  addr of file-var in si      )
(       addr of buffer in di        )
(       nr of records to read in ax )
( out: AX := # of bytes read	    )
      adrpush
      apush	
      adrpush   
      m>b d.bx b>m adrpop adr2+ adr2+ m>b * d.cx a>m
      ds>a d.ds a>m 
      d.dx d>m
      $3F dos intr ?doserr
      d.ax m>a bpop .=. .not. 
      IF
        .0=. flag> adrpop adrpush , $E adrn+ m>al .true=. .>and. 
             IF -1 apop apop apop errorptr ENDIF
        adrpop , $E adrn+ TRUE bl>m
      ELSE
        adrpop , $E adrn+ FALSE bl>m  
      ENDIF  
      d.ax m>a
;      



: fput
( in: addr of buffer   in si       )
(     addr of file-var in di	   )
(     nr of records to write in ax )

      dpush adr>d adrpop adrpush
      m>b d.bx b>m adrpop adr2+ adr2+ m>b * d.cx a>m
      ds>a d.ds a>m 
      d.dx d>m
      $40 dos intr ?doserr
;      

: GETPSP
( arg: - )
( out: psp segment in ES )
  $51 dos intr d.bx m>e
;

: BIOSDELAY
( arg: BX:AX := msec to wait )
  d.cx b>m 
  d.dx a>m
  $15 , $8600 intr
;  
  
  proc nosound
    [ $E4 $61 ]  ( *** in al,[61] *** )
    [ $24 $FC ]  ( *** and al,fc  *** )
    [ $E6 $61 ]  ( *** out al,[61] ** )
  ;
  
  proc sound
    [ $B8 $DD $34 ]
    [ $BA $12 $00 ]
    [ $3B $D3 ]
    [ $73 $1A ]
    [ $F7 $F3 ]
    [ $8B $D8 ]
    [ $E4 $61 ]
    [ $A8 $03 ]
    [ $75 $08 ]
    [ $0C $03 ]
    [ $E6 $61 ]
    [ $B0 $B6 $E6 $43 $8A $C3 $E6 $42 $8A $C7 $E6 $42 ]
  ;

  function delay [ ] 
  ( Delay value in BX )
  var start double ;
  begin 
    b>a 10 / 
    apush
    e= $40 adr $6C es: m>a adr2+ es: m>b
    e= 0 dpop d/+
    start ba>local 
    begin
       e= $40 adr $6C es: m>a adr2+ es: m>b
       start local>ed d/-
       , $8000 and .0=.
    until
  ;
  


var (execstr) byte 128 ;

record (execparam) 
 var envseg word ;
 var cmdofs [ (execstr) ] ;
 var cmdseg word ;
 var fcb1ofs word ;
 var fcb1seg word ;
 var fcb2ofs word ;
 var fcb2seg word ;
;

: (OS-EXEC)
( arg: si = path )
  adr>a d.dx a>m
  ds>a d.ds a>m d.es a>m
  (execparam)_cmdseg a>m
  (execparam) adr>a d.bx a>m
  $4B , 0 dos intr 
;

: dosexitcode
( arg:- )
( out: dosexitcode in Ax )

  $4D dos intr
  d.ax m>a
;
  