(
        ************************************************************
        *         NAXOS Version 2.14  16-Bit Runtime library       *
        *                                                          *
	*    STANDARD-INPUT-OUTPUT ROUTINES / FILESYSTEM SUPPORT   *
        *                         V. 1.1                           *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 14A 27.11.95                   *
        *                                                          *
        ************************************************************
)

const eof 26 ;

typ file    
    [ *$0      				( Handle  +$00 )
      *$0012   				( Mode    +$02 )
      *$0001  				( RecSize +$04 )
      &$0			        ( BufPtr  +$06 )
      &$0				( NamePtr +$0A )	
      true				( EOF-flag+$0E )
      $0			 	( Scratch +$0F )
    ] ;


var stdin    
    [ *$0      				( Handle  +$00 )
      *$0010   				( Mode    +$02 )
      *$0001  				( RecSize +$04 )
      &$0			        ( BufPtr  +$06 )
      &$0
      false
      0	
    ] ;
    
var stdout
    [ *$1      				( Handle  +$00 )
      *$0011   				( Mode    +$02 )
      *$0001  				( RecSize +$04 )
      &$0			        ( BufPtr  +$06 )
      &$0
      false
      0
    ] ; 	
var stderr
    [ *$2      				( Handle  +$00 )
      *$0011   				( Mode    +$02 )
      *$0001  				( RecSize +$04 )
      &$0			        ( BufPtr  +$06 )
      &$0
      false
      0
    ] ;  	 
var aux
    [ *$3      				( Handle  +$00 )
      *$0012   				( Mode    +$02 )
      *$0001  				( RecSize +$04 )
      &$0			        ( BufPtr  +$06 )
      &$0
      false
      0
    ] ;  
   
var printer
    [ *$4      				( Handle  +$00 )
      *$0012   				( Mode    +$02 )
      *$0001  				( RecSize +$04 )
      &$0			        ( BufPtr  +$06 )
      &$0 
      false
      0	
    ] ;

( *** drive- and directory-functions *** )


: fassign 
( in: adr of Namestring in SI )
(     adr of file-var in DI )	
( out: - )
( chg: AX,BX )

dpush
[ $83 $C7 $0A ] ( add di,0AH )
[ $1E $07 ] 	( push ds pop es )
adr>a 		( save string addr )
d>adr a>m adr2+ e>m			( store string addr in file-var+$0A )
dpop
filemode m>b d>adr , 2 adrn+ b>m	( store filemode in file-var+$02 )
recsize m>b d>adr , 4 adrn+ b>m		( store recsize in file-var+$04 )
;

MACRO fopen
  (fopen)
;

MACRO fcreate
  (fcreate)
;

MACRO fclose
  (fclose)
;

MACRO filepos
  (filepos)      
;

MACRO fseek
  (fseek)
;  

: .fattr
 15 tab -lead0
 dirsize  dpush d= 7  ud.r   dpop  25 tab lead0
 dirdate  
          apush bpush adr>a  2 u.r '.' emit apop  2 u.r
          '.' emit apop  2 u.r 
           36 tab 
 dirtime  bpush  2 u.r ':' emit apop  2 u.r 45 tab 
dirattr   2 u.r
;


: .eof.  
( arg: SI := FILE-ADDR )
( out: CF := 1 end-of-file reached )
( chg: si,al )
  , $E adrn+ m>al .TRUE=. 
;

var (PUTBUF) byte 4 ;


: fputb
( arg: value in bl            )
(      addr of file-var in si )
     
      adrpush
      (PUTBUF) bl>m      
      , 1 dpop fput
;      

: fputw
( arg: value in bx            )
(      addr of file-var in si )
      
      adrpush
      (PUTBUF) b>m      
      , 2 dpop fput
;      

: fputd
( arg: value in bx:ax         )
(      addr of file-var in si )

      adrpush
      (PUTBUF) ba>m      
      , 4 dpop fput
;      


: fput$
( arg:  addr of string in si )
(	addr of file-var in di )
    adrpush strlen adrpop 
    fput
;

: fgetb
( arg: addr of file-var in si )
( out: al )
  d= (PUTBUF) , 1 fget
  (PUTBUF) m>al
;      

: fgetw
( arg: addr of file-var in si )
( out: al )
  d= (PUTBUF) , 2 fget
  (PUTBUF) m>a
;      

: fgetd
( arg: addr of file-var in si )
( out: al )
  d= (PUTBUF) , 4 fget
  (PUTBUF) m>ba
;      

var (get$ptr) nptr ;

function fget$ [ ]
( arg: addr of file-var in si )
(      addr of string in di   )
( out: string addr in si      )
var stradr word ;
var fileadr word ;
begin
  adr>a fileadr a>local
  stradr d>local
  d>a adr (get$ptr) a>m
  fileadr local>adr .eof. .not. if
  begin
   fileadr local>adr fgetb
   13 .=. IF  fileadr local>adr fgetb .T.
   	  ELSE  (get$ptr) al>m adr (get$ptr) mem+ .F.
	  ENDIF	
   flag> fileadr local>adr .eof. .>or.
  until
  fileadr local>adr .eof. if adr (get$ptr) mem- endif
  endif
  (get$ptr) 0 bl>m 
  stradr local>adr
;


function scanf [ ]
( arg: addr of file-var in si )
(      addr of string in di   )
(      separator in al 	      ) 
( out: string addr in si      )
var stradr word ;
var fileadr word ;
var sepch byte ;
begin
  adrpush
  sepch al>local
  apop fileadr a>local
  stradr d>local
  d>a adr (get$ptr) a>m
  fileadr local>adr .eof. if -1 apop apop errorptr endif
  begin
   fileadr local>adr fgetb
   sepch local>bl .=. IF  .T.
	    	    ELSE  (get$ptr) al>m adr (get$ptr) mem+ .F.
	 	    ENDIF	
   flag> fileadr local>adr .eof. .>or.
  until
  fileadr local>adr .eof. if adr (get$ptr) mem- endif
  (get$ptr) 0 bl>m
  stradr local>adr
;


proc paramcount
( ********************************** )
( * returns # of command line args * )
( * arg: -			   * )
( * out: AX := # of cmd line args  * )
( * chg: ax bx di cx es		   * )
( ********************************** )
GETPSP
adr $80
es: m>al .0=. IF d= 0 ELSE
adr+ d= 0
a>b FOR
 es: m>al adr+ $20 .=. IF d+ ENDIF 
NEXT
ENDIF
 d>a
;

var (*paramstr) double ;
var (paramstr) string $80 ;
var (paramstr2) string $80 ;

: paramstr
( ********************************** )
( * returns command line args      * )
( * arg: cli-arg# in bx 	   * )
( * out: SI := cli arg-string      * )
( * chg: ax bx di cx es		   * )
( ********************************** )
bpush 
GETPSP
(*paramstr) d= $81 ed>m
adr $80 es: m>al 
(paramstr) ptr adr>d (*paramstr) memcpy
(paramstr) $0D strpos 
(paramstr) adrn+ adr- 0 bl>m
(*paramstr) 0 b>m
(paramstr)
begin
  m>al 32 .=. IF adrpush  (*paramstr) mem+ adrpop ENDIF
  adr+
  adrpush  (*paramstr) m>a adrpop
  bpop bpush .=. 
until
 bpop
 to (paramstr2) strcpy    
 (paramstr2) $20 strpos adrn+ adr- 0 bl>m
 (paramstr2)
;


: EXEC
( ARG: SI = PATH    )
(      AX = CMDLINE )
  adrpush
  a>adr to (execstr) d+ d+ strcpy
  (execstr) adr2+ strlen (execstr) 1+ al>m adr+ $20 bl>m adrn+ adr+ 13 bl>m
  adrpop
  (OS-EXEC)
  IF d.ax m>b apop errorptr
  ENDIF
;
