(

        ************************************************************
        *         NAXOS Version 2.13  16-Bit Runtime library       *
        *                                                          *
        *                 SYSTEM routines V1.00                    *
        *                                                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 13B 25.08.93                   *
        *                                                          *
        ************************************************************
)
        ( *** program structures ** )
        
        macro I [ $89 $C8 ]     ( mov ax,cx ) ;

       		   MACRO j 
	( ** outer loopindex to AX ** )
	( *************************** )
	( arg: -                      )
	( out: AX:= loopindex         )
	( chg: AX                     )
	( *************************** )
	[ $58 $50 ]  ( pop ax push ax )
	;

		 MACRO j>adr 
	( ** outer loopindex to SI ** )
	( *************************** )
	( arg: -                      )
	( out: SI:= loopindex         )
	( chg: SI                     )
	( *************************** )
	[ $5B $53 ]  ( pop si push si )
	;

		 MACRO leave 
	( * continue to loop and leave * )
	( ****************************** )
	( arg: -                         )
	( out: -                         )
	( chg: -                         )
	( ****************************** )      
	[ $89 $0E UpperLoopLimit ] ( mov [$0014],cx )
	;

   		 MACRO exit 
	( exit current colon or proc )
	( ************************** )
	( arg: -                     )
	( out: -                     )
	( chg: -                     )
	( ************************** )
	[ $C3 ]                ( ret )
	;


	proc halt 
	( ** Programmabbruch  ** )
	( * Arg: BX = EXITCODE * )
	 exit-byte bl>m
	 exitcode
	 [ $FF $E6 ]    ( jmp si )
	;

 
	( ** Fehlermeldungen MSDOS ** )

		 : errmsg 
	( ** Error messages      *** )
	( arg: BX = error number     )
	(      AX = error address    )
	( out: ?, CF=1               )
	( chg: ?                     )
	( ************************** )
        (long)
  	     exit-byte bl>m
             apush
   	     b>a 
	     case
	    *-3 of  " NX-RTE: Application error" ;;
	    *-2 of  " NX-RTE: Volume capacity exceeded"  ;;
	    *-1 of  " NX-RTE: End-of-file reached"  ;;
	    $01 of  " DOS-01: Illegal function" ;;
	    $02 of  " DOS-02: File not found"  ;;
	    $03 of  " DOS-03: Path not found"  ;;
	    $04 of  " DOS-04: Too many open files"  ;;
	    $05 of  " DOS-05: Acces denied"  ;;
	    $06 of  " DOS-06: Invalid handle"  ;;
	    $08 of  " DOS-08: Insufficient memory" ;;
	    $0A of  " DOS-10: Invalid environment" ;;
	    $0B of  " DOS-11: Invalid format"  ;;
	    $0C of  " DOS-12: Illegal access-code"  ;;
	    $0D of  " DOS-13: Data invalid" ;;
	    $0E of  " DOS-14: Unknown unit" ;;
	    $0F of  " DOS-15: Illegal drive"  ;;
	    $10 of  " DOS-16: Can't remove current directory" ;;
	    $11 of  " DOS-17: Not same device"  ;;
	    $12 of  " DOS-18: No more files"  ;;
	    $13 of  " DOS-19: Disk write-protected" ;;
	    $14 of  " DOS-20: Unknown unit" ;;	    
	    $15 of  " DOS-21: Drive not ready" ;;
	    $17 of  " DOS-23: Data CRC error" ;;
	    $19 of  " DOS-25: Seek error" ;;
	    $1B of  " DOS-27: Sector not found" ;;
	    $1C of  " DOS-28: Printer out of paper" ;;
	    $1D of  " DOS-29: Write fault" ;;
	    $1E of  " DOS-30: Read fault" ;;
	    $1F of  " DOS-31: General failure" ;;
	    $20 of  " DOS-32: Sharing violation" ;;
	    $21 of  " DOS-33: Lock violation" ;;
	    $50 of  " DOS-80: file already exists"  ;;
            $80 OF " XMS-ERR: function not implemented" ;;
	    $81 OF " XMS-ERR: VDISK detected" ;;
  	    $82 OF " XMS-ERR: A20 error occurred" ;;
	    $8E OF " XMS-ERR: general XMS driver error" ;;
	    $8F OF " XMS-ERR: unrecoverable XMS driver error" ;;
 	    $90 OF " XMS-ERR: HMA doesn't exist" ;;
	    $91 OF " XMS-ERR: HMA is already in use" ;;
	    $92 OF " XMS-ERR: DX less than /HMAMIN= parameter" ;;
	    $93 OF " XMS-ERR: HMA isn't allocated" ;;
	    $94 OF " XMS-ERR: A20 line is still enabled" ;;
	    $A0 OF " XMS-ERR: all is completely allocated" ;;
	    $A1 OF " XMS-ERR: all available handles are allocated" ;;
	    $A2 OF " XMS-ERR: invalid handle" ;;
	    $A3 OF " XMS-ERR: invalid source handle" ;;
	    $A4 OF " XMS-ERR: invalid source offset" ;;
	    $A5 OF " XMS-ERR: invalid destination handle" ;;  
	    $A6 OF " XMS-ERR: invalid destination offset" ;;
	    $A7 OF " XMS-ERR: invalid block length" ;;
	    $A8 OF " XMS-ERR: invalid move-overlap" ;;
	    $A9 OF " XMS-ERR: parity error" ;;
	    $AA OF " XMS-ERR: block isn't locked" ;;
	    $AB OF " XMS-ERR: block is locked" ;;
	    $AC OF " XMS-ERR: block lock count overflow" ;;
	    $AD OF " XMS-ERR: lock failed" ;;
	    $B0 OF " XMS-ERR: only a smaller UMB is available" ;;
	    $B1 OF " XMS-ERR: no UMB's available" ;;
	    $B2 OF " XMS-ERR: invalid UMB segment number" ;;
            $C8 of  " NX-RTE: Division by zero" ;;
	    $C9 of  " NX-RTE: Heap overflow" ;;
	    $CA of  " NX-RTE: Invalid pointer operation" ;;
	    $CB of  " NX-RTE: NPU initialization error " ;;
	    $CD of  " NX-RTE: X386 initialization failure (PM-active)" ;;
            $FF of  " *** USER BREAK" ;;
	     else   " unexpected Error " $.  byte.h  " (h)"
	    endcase 
	     $.
	     "  at " $. cs>a u.h ':' emit apop u.h cr
             exit-byte m>bl
	(short)
	;


	         proc (runtime)
	           errmsg
	           halt    
	         ;

		 proc (doserrex) 
	( ** exit after dos-runtime-error ** )
	( arg: BX = doserrornumber           )
	(      AH = function#                )
	(      AL = subfunction#             )
	( out: ?                             )
	( chg: ?                             )
	( ********************************** )
	  apush bpush dpush
	  make emit (emit)
	  dpop bpop apop apop apop
	  errmsg halt
	;

	proc (int0ex)  ( - )
	( ** Division by Zero ** )
	( Program abortion    )
	  [ $89 $E3 $36 $8B $07 ] apush
	  ds!
	  apop 200 errorptr
	;

	proc (breakex) ( - )
	( ** Break-Handler with EXIT ** )
	  ds!
	  APOP 255 errorptr
	;

	     proc (breakfl) 
	( **  Set breakflag  ** )
	( interrupt $23 handler )
	( ********************* )
	( arg: -                )
	( out: -                )
	( chg: -                )
	( ********************* )
	[ $C6 6 $19 0 $FF ] ( mov [19],-1 )
	[ $CF ]             ( iret        )
	;

	    : initbreakfl 
	( ** break via flag ** )
	( ******************** )
	( arg: -               )
	( out: -               )
	( chg: -               )
	( ******************** )
	make break (breakfl)
	;


	     : initint 
	( ** init interrupts )
	( ****************** )
	( arg: -             )
	( out: -             )
	( chg: ?             )
	( ****************** )
	make errorptr (runtime)
	make doserr (doserrex)
	make break  (breakex)
	make int0   (int0ex)  
	$23 cs>e   ( Segment )
	d= break ( Break-vec )
	setint 
	0 cs>e     ( Segment )
	d= int0   ( Int0-vec )
	setint
	;


	: memrelease 
	 ( => -,? )
	      ( - )
	      ( ? )
	( ** Gib Memory oberhalb von SP0 an DOS zurck ** )
	 nxparas D.bx a>m cs>a D.es a>m
	  $4A dos intr ?doserr  ( Segmentgre ndern )
	;


	       :  init 
	(  initialize screen  )
	(    and interrupts   )
	( ******************* )
	( arg: -              )
	( out: -              )
	( chg: ?              )
	( ******************* )
	meminit >default initint memrelease
	;

	       :  initnomem 
	(  initialize screen  )
	(    and interrupts   )
	( ******************* )
	( arg: -              )
	( out: -              )
	( chg: ?              )
	( ******************* )
	>default initint memrelease
	;

