program IDE;
{$R-}
{$X+,S-}
{$M 16384,32767,200000}

uses Dos, Objects, Drivers, Memory, Views, Menus, Dialogs,
     StdDlgd, MsgBox, Gadgets, App, rechner,
     Buffers, Editd,asciitab,color_d;

const
  Version      = '2.12';
  Release      = '14.04.1993';
  maxmsg       = 200;
  HeapSize     = 32 * (1024 div 16);
  builder      : string[80] = 'NXMAKE.EXE';
  compiler     : string[80] = 'NX.EXE';
  switches     : string[32] = '';

  coptionen    : word = 1;
  debugger     : string[32] = '\DOS\DEBUG.EXE';
  debcmd1      : string[32] = '';
  debcmd2      : string[32] = '';

  cmOpen       = 200;
  cmNew        = 201;
  cmChangeDir  = 202;
  cmDosShell   = 203;
  cmCalculator = 204;
  cmShowClip   = 205;
  cmrun        = 206;
  cmcompile    = 207;
  cmbuild      = 218;
  cmascii      = 208;
  cmdebug      = 209;
  cminfo       = 210;
  cmlogo       = 211;
  cmfarbe      = 212;
  cmdebopt     = 213;
  cmcomopt     = 214;
  cmsopt       = 215;
  cmlopt       = 216;
  cmfindrte    = 217;

type

  cnfdat = record
             coptionen    : word;
             debugger     : string[32];
             debcmd1      : string[32];
             debcmd2      : string[32];
             farben       : TPalette;
           end;
  dbgdat = record
             debugger     : string[32];
             debcmd1      : string[32];
             debcmd2      : string[32];
           end;

var
  crtreg   : word absolute $0040:$0063;
  dta      : pointer;
  rteadr   : word;
  event    : TEvent;
  inffile  : FNameStr;
  SysPfad  : dirstr;
  ef       : text;
  maxerr,i : byte;
  errmsg   : array[0..155] of string[40];
  nxmsg    : array[1..maxmsg] of string[40];
  cnfdaten : cnfdat;
  dbgdaten : dbgdat;
  xlbfilename:string;
  build_ok : boolean;
  build_err: word;
  build_ep : word;
  result   : record
             case boolean of
             true : ( errorpos:word;
                      errorwort:string[16] );
             false: ( main,data,stack,heap,zeilen,code : word );
             end;

type

  pcnf = ^cnf;

  cnf  = object(TObject)
          data : cnfdat;
          constructor init(var x:cnfdat);
          constructor load(var s:TStream);
          procedure store (var s:TStream);
         end;

  constructor cnf.init(var x:cnfdat);
  begin
     data := X;
  end;

  constructor cnf.load(var s:TStream);
  begin
    S.read(data,sizeof(data));
  end;

  procedure cnf.store(var s:TStream);
  begin
    S.write(data,sizeof(data));
  end;


const

  rcnf : TStreamRec=(
           objtype : 1100;
           VmtLink: Ofs(TypeOf(cnf)^);
           Load:    @cnf.Load;
           Store:   @cnf.Store
           );


type

  pwin = ^twin;
  twin = object(TWindow)
         end;
  pbut = ^tbut;
  tbut = object(TButton)
         end;
  PEditorApp = ^TEditorApp;
  TEditorApp = object(TApplication)
    clock : pclockview;
    heap  : pheapview;
    constructor Init;
    destructor Done; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure idle;virtual;
    procedure InitMenuBar; virtual;
    procedure InitStatusLine; virtual;
    procedure OutOfMemory; virtual;
  end;


var
  EditorApp: TEditorApp;
  ClipWindow: PEditWindow;
  SFileName : Fnamestr;



function ExecDialog(P: PDialog; Data: Pointer): Word;
var
  Result: Word;
begin
  Result := cmCancel;
  P := PDialog(Application^.ValidView(P));
  if P <> nil then
  begin
    if Data <> nil then P^.SetData(Data^);
    Result := DeskTop^.ExecView(P);
    if (Result <> cmCancel) and (Data <> nil) then P^.GetData(Data^);
    Dispose(P, Done);
  end;
  ExecDialog := Result;
end;

function CreateFindDialog: PDialog;
var
  D: PDialog;
  Control: PView;
  R: TRect;
begin
  R.Assign(0, 0, 38, 12);
  D := New(PDialog, Init(R,nxmsg[72]));
  with D^ do
  begin
    Options := Options or ofCentered;

    R.Assign(3, 3, 32, 4);
    Control := New(PInputLine, Init(R, 80));
    Insert(Control);
    R.Assign(2, 2, 18, 3);
    Insert(New(PLabel, Init(R,nxmsg[73], Control)));
    R.Assign(32, 3, 35, 4);
    Insert(New(PHistory, Init(R, PInputLine(Control), 10)));

    R.Assign(3, 5, 35, 7);
    Insert(New(PCheckBoxes, Init(R,
      NewSItem(nxmsg[74],
      NewSItem(nxmsg[75], nil)))));

    R.Assign(14, 9, 24, 11);
    Insert(New(PButton, Init(R,nxmsg[100], cmOk, bfDefault)));
    Inc(R.A.X, 12); Inc(R.B.X, 13);
    Insert(New(PButton, Init(R,nxmsg[101], cmCancel, bfNormal)));

    SelectNext(False);
  end;
  CreateFindDialog := D;
end;

function CreateReplaceDialog: PDialog;
var
  D: PDialog;
  Control: PView;
  R: TRect;
begin
  R.Assign(0, 0, 40, 16);
  D := New(PDialog, Init(R,nxmsg[76]));
  with D^ do
  begin
    Options := Options or ofCentered;

    R.Assign(3, 3, 34, 4);
    Control := New(PInputLine, Init(R, 80));
    Insert(Control);
    R.Assign(2, 2, 18, 3);
    Insert(New(PLabel, Init(R,nxmsg[73], Control)));
    R.Assign(34, 3, 37, 4);
    Insert(New(PHistory, Init(R, PInputLine(Control), 10)));

    R.Assign(3, 6, 34, 7);
    Control := New(PInputLine, Init(R, 80));
    Insert(Control);
    R.Assign(2, 5, 18, 6);
    Insert(New(PLabel, Init(R,nxmsg[77], Control)));
    R.Assign(34, 6, 37, 7);
    Insert(New(PHistory, Init(R, PInputLine(Control), 11)));

    R.Assign(3, 8, 37, 12);
    Insert(New(PCheckBoxes, Init(R,
      NewSItem(nxmsg[74],
      NewSItem(nxmsg[75],
      NewSItem(nxmsg[78],
      NewSItem(nxmsg[79], nil)))))));
    R.Assign(17, 13, 27, 15);
    Insert(New(PButton, Init(R,nxmsg[100], cmOk, bfDefault)));
    R.Assign(28, 13, 39, 15);
    Insert(New(PButton, Init(R,nxmsg[101], cmCancel, bfNormal)));

    SelectNext(False);
  end;
  CreateReplaceDialog := D;
end;

function DoEditDialog(Dialog: Integer; Info: Pointer): Word; far;
var
  R: TRect;
  T: TPoint;
begin
  case Dialog of
    edOutOfMemory:
      DoEditDialog := MessageBox(nxmsg[54],
        nil, mfError + mfOkButton);
    edReadError:
      DoEditDialog := MessageBox(nxmsg[62]+' %s.',
        @Info, mfError + mfOkButton);
    edWriteError:
      DoEditDialog := MessageBox(nxmsg[63]+' %s.',
        @Info, mfError + mfOkButton);
    edCreateError:
      DoEditDialog := MessageBox(nxmsg[64]+' %s.',
        @Info, mfError + mfOkButton);
    edSaveModify:
      DoEditDialog := MessageBox('%s '+nxmsg[61],
        @Info, mfInformation + mfYesNoCancel);
    edSaveUntitled:
      DoEditDialog := MessageBox(nxmsg[60],
        nil, mfInformation + mfYesNoCancel);
    edSaveAs:
      DoEditDialog := ExecDialog(New(PFileDialog, Init('*.*',
        nxmsg[58], nxmsg[57], fdOkButton, 101)), Info);
    edFind:
      DoEditDialog := ExecDialog(CreateFindDialog, Info);
    edSearchFailed:
      DoEditDialog := MessageBox(nxmsg[59],
        nil, mfError + mfOkButton);
    edReplace:
      DoEditDialog := ExecDialog(CreateReplaceDialog, Info);
    edReplacePrompt:
      begin
        { Avoid placing the dialog on the same line as the cursor }
        R.Assign(0, 1, 40, 8);
        R.Move((Desktop^.Size.X - R.B.X) div 2, 0);
        Desktop^.MakeGlobal(R.B, T);
        Inc(T.Y);
        if TPoint(Info).Y <= T.Y then
          R.Move(0, Desktop^.Size.Y - R.B.Y - 2);
        DoEditDialog := MessageBoxRect(R, 'Ersetzen ?',
          nil, mfYesNoCancel + mfInformation);
      end;
  end;
end;

function OpenEditor(FileName: FNameStr; Visible: Boolean): PEditWindow;
var
  P: PView;
  R: TRect;
begin
  DeskTop^.GetExtent(R);
  P := Application^.ValidView(New(PEditWindow,
    Init(R, FileName, wnNoNumber)));
  if not Visible then P^.Hide;
  DeskTop^.Insert(P);
  OpenEditor := PEditWindow(P);
end;

constructor TEditorApp.Init;
var
  FN:string;
  H: Word;
  R: TRect;
  event : tevent;
begin
  H := PtrRec(HeapEnd).Seg - PtrRec(HeapPtr).Seg;
  if H > HeapSize then BufHeapSize := H - HeapSize else BufHeapSize := 0;
  InitBuffers;
  TApplication.Init;
  registertype(rcnf);
  event.what := evcommand;
  event.command := cmlopt;
  handleevent(event);

  DisableCommands([cmSave, cmSaveAs, cmCut, cmCopy, cmPaste, cmClear,cmFindRTE,
    cmUndo, cmFind, cmReplace, cmSearchAgain,cmCompile,cmRun,cmDebug,cmInfo,cmbuild]);
  EditorDialog := DoEditDialog;
  ClipWindow := OpenEditor('', False);
  if ClipWindow <> nil then
  begin
    Clipboard := ClipWindow^.Editor;
    Clipboard^.CanUndo := False;
  end;
  event.what := evcommand;
  getextent(r);
  r.a.x:=r.b.x-9;r.b.y:=r.a.y+1;
  clock:=new(pclockview,init(r));
  insert(clock);

  if paramcount>0 then begin
       FN := paramstr(1);
       if pos('.',FN)=0 then fn := fn+'.FTH';
       openeditor(fn,true)
  end else
  event.command := messagebox(#3'NAXOS-COMPILER V '+version+
                              #13#3'(C) Peper,Zissis,Tossounidis'+
                              #13#3+release
                              ,nil,2+mfokbutton);

end;

destructor TEditorApp.Done;
begin
  TApplication.Done;
  DoneBuffers;
end;

procedure TEditorApp.HandleEvent(var Event: TEvent);

var infile : text;
procedure FileOpen;
var
  FileName: FNameStr;
begin
  SFileName := '*.FTH';
  if ExecDialog(New(PFileDialog, Init('*.FTH',nxmsg[56],
    nxmsg[57], fdOpenButton, 100)), @SFileName) <> cmCancel then
    OpenEditor(SFileName, True);
    disablecommands([cmdebug,cmrun,cminfo]);
    enablecommands([cmcompile,cmFindRTE,cmbuild]);
end;

procedure FileNew;
begin
  OpenEditor('', True);
  disablecommands([cmdebug,cmrun,cminfo]);
  enablecommands([cmcompile,cmFIndRTE,cmbuild]);
end;

procedure ChangeDir;
begin
  ExecDialog(New(PChDirDialog, Init(cdNormal, 0)), nil);
end;

procedure DosShell;
begin
  DoneSysError;
  DoneEvents;
  DoneVideo;
  DoneMemory;
  SetMemTop(Ptr(BufHeapPtr, 0));
  PrintStr(nxmsg[55]);
  SwapVectors;
  Exec(GetEnv('COMSPEC'), '');
  SwapVectors;
  SetMemTop(Ptr(BufHeapEnd, 0));
  InitMemory;
  InitVideo;
  InitEvents;
  InitSysError;
  Redraw;
end;

function hex(n, l: integer): string;

{ n in l-stellige Hexzahl wandeln }

var
  i, z: integer;
  s: string;

begin
  s := '';
  for i := 1 to l do
    begin
      z := n and 15; { Ziffer bilden }
      if z > 9 then z := z + 7;
      s := chr(z + 48) + s;
      n := n shr 4; { Division durch 16 }
    end;
  hex := s;
end;
function dez(n:longint):string;
var s:string;
begin
   str(n:6,s);
   dez := s;
end;

procedure GetInfo;
var msg : string;
    f : text;
    main,here,s0,r0,zeilen,bytes : word;
    P: PathStr;
    D: DirStr;
    N: NameStr;
    E: ExtStr;
begin
    fsplit(idefilename,d,n,e);
    msg := nxmsg[80]+' : '+n+e+#13+
        #3+nxmsg[81]+dez(result.zeilen)      +'      '+nxmsg[84]+'  $'+hex(result.main,4)+#13+
        #3+nxmsg[82]+dez(result.code)        +'      '+nxmsg[85]+' '+dez(result.data)+#13+
        #3+nxmsg[83]+dez(result.stack*16+14) +'      '+nxmsg[86]+' '+dez(longint(result.heap) shl 4);
    event.what := evcommand;
    event.command := messagebox(#3+msg
                              ,nil,mfinformation+mfokbutton);
    handleevent(event);
end;

procedure comp(rte:word);
var msg,s1 : string;
    errwort : string[20];
    ds  : word;
    win : pwin;
    but : pbut;
    R   : TRect;
    x,y :word;
    rtpar : string[20];
begin
  str(rte,rtpar);
  rtpar := '-F '+rtpar;
  R.Assign(20, 7, 60, 16);
  win := new(pwin,init(r,nxmsg[50],0));
  win^.palette := wpGrayWindow;
  win^.flags := 4;
  DeskTop^.insert(win);
  SetMemTop(Ptr(BufHeapPtr, 0));
  SwapVectors;
  case rte of
  0 : Exec(SysPfad+compiler,IDEfilename+' '+switches);
  2 : Exec(SysPfad+compiler,XLBFIlename);
  else  Exec(SysPfad+compiler,IDEfilename+' '+rtpar);
  end;
  SwapVectors;
  move(dta^,result,19);
  event.what := evcommand;
  event.command := cmprev;
  handleevent(event);
  win^.done;
  ds := dosexitcode;
  if rte=2 then begin
    if ds=0 then build_ok := true else begin
      build_ok := false ;
      build_err := ds-100;
      build_ep  := result.errorpos;
     end
  end else
  begin
   if ds<>0 then begin
    ds := ds-100;
    str(ds:3,msg);
    if (ds<>0)  then msg := errmsg[ds];
    if ds<100 then begin
       msg := dez(ds)+' '+nxmsg[51]+dez(result.errorpos)+#13+#3+msg+#13+#3+result.errorwort;
    end;
    event.what := evcommand;
    event.command := messagebox(#3+msg+#13+#3+nxmsg[49],nil,mferror);
    handleevent(event);
    if (ds<100) then begin
       event.what := evcommand;
       event.command := cmTextGoto;
       event.Infoword := result.errorpos;
       handleevent(event);
    end;
   end
   else begin
     enablecommands([cmdebug,cmrun,cminfo,cmFindRTE,cmbuild]);
     if rte<>2 then getinfo;
   end;
  end;
  SetMemTop(Ptr(BufHeapEnd, 0));
  Redraw;
end;

procedure BUILD;
var r:trect;
    win:pwin;
    ds:word;
    cname: string;
    msg : string;
begin
  cname := idefilename;
  if pos('.',cname)<>0 then cname := copy(cname,1,pos('.',cname)-1);
  xlbfilename := cname+'.$$$';
  R.Assign(20, 7, 60, 16);
  win := new(pwin,init(r,nxmsg[151],0));
  win^.palette := wpGrayWindow;
  win^.flags := 4;
  DeskTop^.insert(win);
  SetMemTop(Ptr(BufHeapPtr, 0));
  SwapVectors;
  Exec(SysPfad+BUILDER,cname);
  SwapVectors;
  ds := dosexitcode;
  event.what := evcommand;
  event.command := cmprev;
  handleevent(event);
  win^.done;
  if ds=0 then begin
    comp(2);
    if build_ok then comp(0) else begin
      msg := dez(build_err)+' '+nxmsg[51]+dez(build_ep)+#13+#3+errmsg[build_err]+#13+#3+errmsg[69];
      event.what := evcommand;
      event.command := messagebox(#3+msg,nil,mferror);
      handleevent(event);
      openeditor(xlbfilename,true);
      event.what := evcommand;
      event.command := cmTextGoto;
      event.Infoword := build_ep;
      handleevent(event);
    end;
  end else begin
      event.what := evcommand;
      event.command := messagebox(#3+errmsg[65]+#13+#3+nxmsg[49],nil,mferror);
      handleevent(event);
    end;
end;

procedure filerun;
var stefan : fnamestr;
begin
  DoneSysError;
  DoneEvents;
  DoneVideo;
  DoneMemory;
  SetMemTop(Ptr(BufHeapPtr, 0));
  SwapVectors;
  stefan := copy(idefilename,1,pos('.',idefilename))+'COM';
  exec(stefan,'');
  SwapVectors;
  SetMemTop(Ptr(BufHeapEnd, 0));
  InitMemory;
  InitVideo;
  InitEvents;
  InitSysError;
  Redraw;
end;

procedure debug;
var lfname : string;
begin
  DoneSysError;
  DoneEvents;
  DoneVideo;
  DoneMemory;
  SetMemTop(Ptr(BufHeapPtr, 0));
  SwapVectors;
  lfname := copy(IDEfilename,1,pos('.',IDEfilename))+'COM';
  exec(debugger,' '+debcmd1+' '+lfname+' '+debcmd2);
  SwapVectors;
  SetMemTop(Ptr(BufHeapEnd, 0));
  InitMemory;
  InitVideo;
  InitEvents;
  InitSysError;
  Redraw;
end;


procedure ShowClip;
begin
  ClipWindow^.Select;
  ClipWindow^.Show;
end;

procedure Tile;
var
  R: TRect;
begin
  Desktop^.GetExtent(R);
  Desktop^.Tile(R);
end;

procedure Cascade;
var
  R: TRect;
begin
  Desktop^.GetExtent(R);
  Desktop^.Cascade(R);
end;

procedure Calculator;
begin
  DeskTop^.Insert(ValidView(New(PCalculator, Init)));
end;

procedure AsciiTab;
var
  P: PAsciiChart;
begin
  P := New(PAsciiChart, Init);
  Desktop^.Insert(ValidView(P));
end;

procedure getlogo;
begin
messagebox(#3'NAXOS-COMPILER V '+version+
                              #13#3'(C) Peper,Zissis,Tossounidis'+
                              #13#3+release
                              ,nil,2+mfokbutton);
end;

procedure Farben;
var
  D: PColorDialog;
begin
  D := New(PColorDialog, Init('',
    ColorGroup(nxmsg[87],
      ColorItem(nxmsg[88],            2,
      ColorItem(nxmsg[89],          3,
      ColorItem(nxmsg[90],          4,
      ColorItem(nxmsg[91],          5,
      ColorItem(nxmsg[92], 6,
      ColorItem(nxmsg[93], 7, nil)))))),
    ColorGroup(nxmsg[94],
      ColorItem(nxmsg[95],  33,
      ColorItem(nxmsg[96],       34,
      ColorItem(nxmsg[97],   35,
      ColorItem(nxmsg[98],  36,
      ColorItem(nxmsg[99],       37,

      ColorItem(nxmsg[110],      38,
      ColorItem(nxmsg[111],    39,
      ColorItem(nxmsg[112],    40,

      ColorItem(nxmsg[113],     41,
      ColorItem(nxmsg[114],    42,
      ColorItem(nxmsg[115],   43,
      ColorItem(nxmsg[116],   44,
      ColorItem(nxmsg[117],   45,
      ColorItem(nxmsg[118],     46,

      ColorItem(nxmsg[119],    47,
      ColorItem(nxmsg[120],  48,
      ColorItem(nxmsg[121],  49,

      ColorItem(nxmsg[122],      50,
      ColorItem(nxmsg[123],    51,
      ColorItem(nxmsg[124],       52,

      ColorItem(nxmsg[125],    53,
      ColorItem(nxmsg[126],     54,
      ColorItem(nxmsg[127],  55,
      ColorItem(nxmsg[128], 56,

      ColorItem(nxmsg[129],       57,
      ColorItem(nxmsg[130],      58,
      ColorItem(nxmsg[131],     59,
      ColorItem(nxmsg[132],      60,

      ColorItem(nxmsg[133],  61, nil))))))))))))))))))))))))))))),
    ColorGroup(nxmsg[134],
      ColorItem(nxmsg[135],      8,
      ColorItem(nxmsg[136],       9,
      ColorItem(nxmsg[137],       10,
      ColorItem(nxmsg[138],   11,
      ColorItem(nxmsg[139],  12,
      ColorItem(nxmsg[140],              13, nil)))))),
    ColorGroup(nxmsg[141],
      ColorItem(nxmsg[142],     24,
      ColorItem(nxmsg[143],      25,
      ColorItem(nxmsg[144],       26,
      ColorItem(nxmsg[145],   27,
      ColorItem(nxmsg[146],  28,
      ColorItem(nxmsg[147],              29, nil)))))), nil))))));

  if ValidView(D) <> nil then
  begin
    D^.SetData(Application^.GetPalette^);
    if Desktop^.ExecView(D) <> cmCancel then
    begin
      Application^.GetPalette^ := D^.Pal;
      DoneMemory;  { Dispose all group buffers }
      ReDraw;      { Redraw application with new palette }
    end;
    Dispose(D, Done);
  end;
end;

procedure getrteadr;
  TYPE
    LaufzeitfehlerfindenData = STRING [5];

  VAR
    R: tRect;
    View: pView;
    Data: LaufzeitfehlerfindenData;
    Code: INTEGER;
    Dialog: pDialog;
    dummy : word;
BEGIN
  R.Assign (20, 5, 57, 12);
  Dialog := New (pDialog, Init (R,nxmsg[148]));
  Dialog^.State := 2171;
 
  R.Assign (21, 3, 28, 4);
  View := New (pInputLine, Init (R, 5));
  Dialog^.Insert (View);
  R.Assign (9, 3, 20, 4);
  Dialog^.Insert (New (pLabel, Init (R,nxmsg[149], View)));
  R.Assign (5, 7, 17, 9);
  Dialog^.Insert (New (pButton, Init (R,nxmsg[100],cmok,bfdefault)));
  R.Assign (22, 7, 35, 9);
  Dialog^.Insert (New (pButton, Init (R,nxmsg[101],cmcancel,bfnormal)));

  Dialog^.SelectNext (FALSE);
 
    { Datenrecord initialisieren ! }
  FillChar (Data, SizeOf (LaufzeitfehlerfindenData), 0);
  Dialog^.SetData (Data); 
  Code := Desktop^.ExecView (Application^.ValidView (Dialog));
  IF Code <> cmCancel THEN BEGIN
    Dialog^.GetData (Data);
    val(data,rteadr,dummy);
    if dummy=0 then comp(rteadr) else write(#7);
  END;
  IF Dialog <> NIL THEN 
    Dispose (Dialog, Done);
END;

procedure debopt;
type debdialog = ^TDialog;
     pbut      = ^TButton;
     zle       = ^TInputLine;

var  dialog    : debdialog;
     R         : TRect;
     control   : word;
     dummy     : word;
     zeile1,zeile2,
     zeile3     : zle;
begin
  dbgdaten.debugger := debugger;
  dbgdaten.debcmd1 := debcmd1;
  dbgdaten.debcmd2 := debcmd2;

  r.assign(10,4,70,19);
  Dialog := new(debdialog,init(r,nxmsg[48]));
  with dialog^ do
  begin

    r.assign(23,3,57,4);
    zeile1 := (new(pInputLine,init(r,32)));
    insert(zeile1);
    r.assign(5,3,20,4);
    insert(new(plabel,init(r,'DEBUGGER :',zeile1)));

    r.assign(23,5,57,6);
    zeile2 := (new(pInputLine,init(r,32)));
    insert(zeile2);
    r.assign(5,5,20,6);
    insert(new(plabel,init(r,'PARAMETER 1 :',zeile2)));

    r.assign(23,7,57,8);
    zeile3 := (new(pInputLine,init(r,32)));
    insert(zeile3);
    r.assign(5,7,20,8);
    insert(new(plabel,init(r,'PARAMETER 2 :',zeile3)));

    r.assign(5,12,19,14);
    insert(new(pbut,init(r, nxmsg[101],cmCancel,bfNormal)));
    r.assign(40,12,54,14);
    insert(new(pbut,init(r, nxmsg[100],cmok,bfdefault)));
  end;
  dialog^.setdata(dbgdaten);
  control := desktop^.execview(dialog);
  if control<>cmcancel then begin
     dialog^.getdata(dbgdaten);
  end;
  debugger  := dbgdaten.debugger;
  debcmd1   := dbgdaten.debcmd1;
  debcmd2   := dbgdaten.debcmd2;
  dispose(dialog,done);
end;

procedure comopt;
type comDIALOG = ^TDIALOG;
     PSCHALTER = ^TCHeckBoxes;
     pbut      = ^TButton;

var dialog : comDIALOG;
    R : TRECT;
    schalter : PSCHALTER;
    control : word;
begin
  r.assign(30,5,65,20);
  Dialog := new(comdialog,init(r,nxmsg[47]));
  with dialog^ do
  begin
    r.assign(20,11,30,13);
    insert(new(pbut,init(r, nxmsg[100],cmok,bfdefault)));
    r.assign(4,11,14,13);
    insert(new(pbut,init(r, nxmsg[101],cmCancel,bfNormal)));
    r.assign(5,4,28,9);
    schalter := new(pschalter,init(r,
       newsitem(nxmsg[43],
       newsitem(nxmsg[44],
       nil))
    ));
    insert(schalter);
  end;
  dialog^.setdata(coptionen);
  control := desktop^.execview(dialog);
  if control <> cmcancel then dialog^.getdata(coptionen);
  if (coptionen and $3)=0 then switches := ' -N';
  if (coptionen and $3)=1 then switches := '';
  if (coptionen and $3)=2 then switches := ' -N -M';
  if (coptionen and $3)=3 then switches := ' -M';
  if (coptionen and $4)=0 then compiler := 'NX.EXE'
                          else compiler := 'NXO.EXE';
  if (coptionen and $C)=$C then switches := switches+' -D';
  dispose(dialog,done);
end;


procedure optsave;
var s :pbufstream;
    x :pcnf;
begin
   cnfdaten.coptionen := coptionen;
   cnfdaten.debugger := debugger;
   cnfdaten.debcmd1 := debcmd1;
   cnfdaten.debcmd2 := debcmd2;
   cnfdaten.farben  := Application^.Getpalette^;
   s := new(pbufstream,init(syspfad+'NAXOS.CNF',stcreate,1024));
   x := new(pcnf,init(cnfdaten));
   s^.put(x);
   dispose(s,done);
   dispose(x,done);
end;

procedure optload;
var s: pbufstream;
    x: pcnf;
    f :file;
    p : string;
begin
   assign(f,syspfad+'NAXOS.CNF');
   {$I-} reset(f);{$I+}
   if ioresult=0 then begin
     close(f);
     s := new(pbufstream,init(syspfad+'NAXOS.CNF',stopenread,1024));
     x := new(pcnf,init(cnfdaten));
     x := pcnf(s^.get);
     cnfdaten := x^.data;
     coptionen := cnfdaten.coptionen;
     debugger  := cnfdaten.debugger;
     debcmd1   := cnfdaten.debcmd1;
     debcmd2   := cnfdaten.debcmd2;
     Application^.GetPalette^ := cnfdaten.farben;
     redraw;
     dispose(x,done);
     dispose(s,done);
     if (coptionen and $3)=0 then switches := ' -N';
     if (coptionen and $3)=1 then switches := '';
     if (coptionen and $3)=2 then switches := ' -N -M';
     if (coptionen and $3)=3 then switches := ' -M';
     if (coptionen and $4)=0 then compiler := 'NX.EXE'
                             else compiler := 'NXO.EXE';
     if (coptionen and $C)=$C then switches := switches+' -D';
   end;
end;


begin
  TApplication.HandleEvent(Event);
  case Event.What of
    evCommand:
      case Event.Command of
        cmOpen: FileOpen;
        cmNew: FileNew;
        cmChangeDir: ChangeDir;
        cmDosShell: DosShell;
        cmCalculator: Calculator;
        cmShowClip: ShowClip;
        cmTile: Tile;
        cmCascade: Cascade;
        cmbuild:   begin
                    event.what := evcommand;
                    event.command := cmsave;
                    handleevent(event);
                    build;
                   end;
        cmcompile: begin
                    event.what := evcommand;
                    event.command := cmsave;
                    handleevent(event);
                    comp(0);
                   end;
        cmfindrte: begin
                    event.what := evcommand;
                    event.command := cmsave;
                    handleevent(event);
                    getrteadr;
                   end;
        cmrun : filerun;
        cmascii:asciitab;
        cmdebug : debug;
        cminfo : getinfo;
        cmlogo : getlogo;
        cmfarbe: farben;
        cmdebopt:debopt;
        cmcomopt:comopt;
        cmsopt  :optsave;
        cmlopt  :optload;
      else
        Exit;
      end;
  else
    Exit;
  end;
  ClearEvent(Event);
end;

procedure TEditorApp.Idle;

function IsTileable(P: PView): Boolean; far;
begin
  IsTileable := P^.Options and ofTileable <> 0;
end;

begin
  TApplication.Idle;
  Clock^.Update;
  inffile := copy(idefilename,1,pos('.',idefilename)-1)+'.INF';
  if Desktop^.FirstThat(@IsTileable) <> nil then
    EnableCommands([cmTile, cmCascade])
  else
    DisableCommands([cmTile, cmCascade]);
  if idefilename ='' then Disablecommands([cmcompile,cmrun,cmdebug,cminfo,cmFindRTE,cmbuild])
                     else Enablecommands([cmcompile,cmFindRTE,cmbuild]);
end;


procedure TEditorApp.InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    Newsubmenu(nxmsg[1],hcnocontext,newmenu(
      NewItem(nxmsg[2], '', kbNoKey, cmCalculator, hcNoContext,
      newitem(nxmsg[3],'',kbnokey,cmascii, hcnocontext,
      newline(
      newitem(nxmsg[4],'',kbnokey,cmlogo,hcnocontext,nil))))),
    NewSubMenu(nxmsg[5], hcNoContext, NewMenu(
      NewItem(nxmsg[6], 'F3', kbF3, cmOpen, hcNoContext,
      NewItem(nxmsg[7], '', kbNoKey, cmNew, hcNoContext,
      NewItem(nxmsg[8], 'F2', kbF2, cmSave, hcNoContext,
      NewItem(nxmsg[9], '', kbNoKey, cmSaveAs, hcNoContext,
      NewLine(
      NewItem(nxmsg[10], '', kbNoKey, cmChangeDir, hcNoContext,
      NewItem(nxmsg[11], '', kbNoKey, cmDosShell, hcNoContext,
      NewItem(nxmsg[12], 'Alt-X', kbAltX, cmQuit, hcNoContext,
      nil))))))))),
    NewSubMenu(nxmsg[13], hcNoContext, NewMenu(
      NewItem(nxmsg[14], '', kbNoKey, cmUndo, hcNoContext,
      NewLine(
      NewItem(nxmsg[15], 'Shift-Del', kbShiftDel, cmCut, hcNoContext,
      NewItem(nxmsg[16], 'Ctrl-Ins', kbCtrlIns, cmCopy, hcNoContext,
      NewItem(nxmsg[17], 'Shift-Ins', kbShiftIns, cmPaste, hcNoContext,
      NewItem(nxmsg[18], '', kbNoKey, cmShowClip, hcNoContext,
      NewLine(
      NewItem(nxmsg[19], 'Ctrl-Del', kbCtrlDel, cmClear, hcNoContext,
      nil))))))))),
    NewSubMenu(nxmsg[20], hcNoContext, NewMenu(
      NewItem(nxmsg[21], '', kbNoKey, cmFind, hcNoContext,
      NewItem(nxmsg[22], '', kbNoKey, cmReplace, hcNoContext,
      NewItem(nxmsg[41], '', kbNoKey, cmSearchAgain, hcNoContext,
      NewItem(nxmsg[148],'', kbNoKey, cmFindrte, hcNoContext,
      nil))))),
    newsubmenu(nxmsg[23],hcnocontext,newmenu(
      newitem(nxmsg[24],'Ctrl-F9',kbctrlf9,cmrun,hcnocontext,
      newitem(nxmsg[150],'Shift-F9',kbshiftf9,cmbuild,hcnocontext,
      newitem(nxmsg[25],'F9',kbf9,cmcompile,hcnocontext,
      newitem(nxmsg[26],'Alt-F9',kbaltf9,cminfo,hcnocontext,
      nil))))),
    newitem(nxmsg[27],'',kbf7,cmdebug,hcnocontext,
    NewSubMenu(nxmsg[28], hcNoContext, NewMenu(
      NewItem(nxmsg[42],'Ctrl-F5', kbCtrlF5, cmResize, hcNoContext,
      NewItem(nxmsg[29], 'F5', kbF5, cmZoom, hcNoContext,
      NewItem(nxmsg[30], '', kbNoKey, cmTile, hcNoContext,
      NewItem(nxmsg[31], '', kbNoKey, cmCascade, hcNoContext,
      NewItem(nxmsg[32], 'F6', kbF6, cmNext, hcNoContext,
      NewItem(nxmsg[33], 'Shift-F6', kbShiftF6, cmPrev, hcNoContext,
      NewItem(nxmsg[34], 'Alt-F3', kbAltF3, cmClose, hcNoContext,
      nil)))))))),
    newsubmenu(nxmsg[35],hcnocontext,newmenu(
      newitem(nxmsg[36],'',kbnokey,cmfarbe,hcnocontext,
      newitem(nxmsg[37],'',kbnokey,cmdebopt,hcnocontext,
      newitem(nxmsg[38],'',kbnokey,cmcomopt,hcnocontext,
      newline(
      newitem(nxmsg[39],'',kbnokey,cmsopt,hcnocontext,
      newitem(nxmsg[40],'',kbnokey,cmlopt,hcnocontext,
      nil))))))),
    nil)))))))))))
end;

procedure TEditorApp.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      NewStatusKey(nxmsg[65], kbF2, cmSave,
      NewStatusKey(nxmsg[66], kbF3, cmOpen,
      NewStatusKey(nxmsg[67], kbAltF3, cmClose,
      NewStatusKey(nxmsg[68], kbF5, cmZoom,
      NewStatusKey(nxmsg[69], kbF6, cmNext,
      NewStatusKey(nxmsg[70], kbF10, cmMenu,
      NewStatusKey(nxmsg[71], kbCtrlF5, cmResize,
      nil))))))),
    nil)));
end;

procedure TEditorApp.OutOfMemory;
begin
  MessageBox(nxmsg[54],
    nil, mfError + mfOkButton);
end;


begin
  dta := ptr($B800,140);
  if crtreg=$03B4 then dta := ptr($B000,140);
  SysPfad := getenv('NAXOS');
  if syspfad='' then begin
     writeln('NAXOS V',Version,' : SET NAXOS=???????',#7);
     halt(0);
  end else syspfad:=syspfad+'\';
  assign(ef,SysPfad+'NAXOS.ERR');
  {$I-}  reset(ef); {$I+}
  for i := 0 to 155 do errmsg[i] := 'ERROR';
  if ioresult=0 then begin
    repeat
      read(ef,i);
      readln(ef,errmsg[i]);
    until eof(ef);
    close(ef);
  end;
  assign(ef,SysPfad+'NAXOS.MSG');
  {$I-}  reset(ef); {$I+}
  for i := 1 to maxmsg do nxmsg[i] := '';
  if ioresult=0 then begin
    repeat
      read(ef,i);
      readln(ef,nxmsg[i]);
      while nxmsg[i][1]=' ' do delete(nxmsg[i],1,1);
    until eof(ef);
    close(ef);
  end;

  EditorApp.Init;
  EditorApp.Run;
  EditorApp.Done;
end.
